/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "dlist.h"
#include "locstr.h"
#include "string.h"
#include <stdio.h>
#include "face/edit.h"

tAddr::tAddr() {
    protocol=host=username=pass=path=file=NULL;
    port=0;
};

void tAddr::print() {
    if (protocol) printf("protocol: %s\n",protocol);
    if (host) printf("host: %s\n",host);
    if (path) printf("path: %s\n",path);
    if (file) printf("file: %s\n",file);
    if (username) printf("username: %s\n",username);
    if (pass) printf("pass: %s\n",pass);
    printf("port: %i\n",port);
};

tAddr::~tAddr() {
    if (protocol) delete(protocol);
    if (path) delete(path);
    if (pass) delete(pass);
    if (username) delete(username);
    if (host) delete(host);
};

/**********************************************/
void make_url_from_download(tDownload *what,char *where) {
    *where=0;
    strcat(where,what->info->protocol);
    strcat(where,"://");
    if (what->info->username && !equal(what->info->username,"anonymous")) {
        strcat(where,what->info->username);
        strcat(where,":");
        if (what->info->pass) strcat(where,what->info->pass);
        strcat(where,"@");
    };
    strcat(where,what->info->host);
    strcat(where,what->info->path);
    if (what->info->path[strlen(what->info->path)-1]!='/')
        strcat(where,"/");
    strcat(where,what->info->file);
};

char *make_simply_url(tDownload *what) {
    char *URL=new char[strlen(what->info->protocol)+strlen(what->info->host)+
                       strlen(what->info->path)+strlen(what->info->file)+6];
    *URL=0;
    /* Easy way to make URL from info  field
     */
    strcat(URL,what->info->protocol);
    strcat(URL,"://");
    strcat(URL,what->info->host);
    strcat(URL,what->info->path);
    if (what->info->path[strlen(what->info->path)-1]!='/')
        strcat(URL,"/");
    strcat(URL,what->info->file);
    return URL;
};
/**********************************************/
void tTriger::reset(){
	old=curent;
};

void tTriger::clear(){
	old=curent=0;
};

void tTriger::set(int a ){
	curent=a;
};

int tTriger::change(){
	return old==curent?0:1;
};
/**********************************************/
tDownload::tDownload() {
    next=prev=NULL;
    who=NULL;
    info=NULL;
    LOG=NULL;
    SavePath=NULL;
    FullSize=-1;
    FileType=0;
    FileBody=NULL;
    Start=Pause=0;
    Percent.clear();
    Attempt.clear();
    Status.clear();
    Size.clear();
    owner=DL_ALONE;
    thread_id=0;
    editor=NULL;
    GTKCListRow=-1;
};

void tDownload::clear() {
    if (who) {
        delete(who);
        who=NULL;
    };
};

void tDownload::delete_editor() {
    if (editor)
        delete editor;
};

void tDownload::print() {
    //do nothing
};

tDownload::~tDownload() {
    if (who) delete who;
    if (info) delete info;
    if (LOG) delete LOG;
    if (SavePath) delete SavePath;
    if (FileBody) delete FileBody;
    if (editor) delete editor;
};


//**********************************************/

tDList::tDList() {
    First=Last=NULL;
};

tDList::tDList(int key) {
    First=Last=NULL;
    OwnerKey=key;
};

int tDList::owner(tDownload *which) {
    if (which && which->owner==OwnerKey) return 1;
    return 0;
};

void tDList::insert(tDownload *what) {
    what->owner=OwnerKey;
    tQueue::insert(what);
};

void tDList::insert_before(tDownload *what,tDownload *where) {
    what->owner=OwnerKey;
    tQueue::insert_before(what,where);
};

void tDList::del(tDownload *what) {
    if (owner(what)) tQueue::del(what);
    else puts("***WARN***!!!"
                  "Attempt to delete download from list which does'nt contain it!");
};

void tDList::forward(tDownload *what) {
    if (what->next) {
        tDownload *temp=(tDownload *)(what->next);
        if ((temp->prev=what->prev))
            what->prev->next=temp;
        else
            Last=what->next;
        what->prev=temp;
        if ((what->next=temp->next))
            temp->next->prev=what;
        else
            First=what;
        what->prev->next=what;
    };
};

void tDList::backward(tDownload *what) {
    if (what->prev) {
        tDownload *temp=(tDownload *)(what->prev);
        if ((temp->next=what->next))
            what->next->prev=temp;
        else
            First=what->prev;
        what->next=temp;
        if ((what->prev=temp->prev))
            temp->prev->next=what;
        else
            Last=what;
        what->next->prev=what;
    };
};

tDownload *tDList::last() {
    return (tDownload *)(Curent=Last);
};

tDownload *tDList::first() {
    return (tDownload *)(Curent=First);
};

tDownload *tDList::next() {
    Curent=Curent->next;
    return (tDownload *)Curent;
};

tDownload *tDList::prev() {
    Curent=Curent->prev;
    return (tDownload *)Curent;
};

tDList::~tDList() {
    done();
};
