/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <gtk/gtk.h>
#include <stdio.h>
#include "../main.h"
#include "../var.h"
#include "../locstr.h"
#include "edit.h"
#include "list.h"

extern tMain aa;

tDownload *OneDownload=NULL;

void add_window_cancel() {
    delete OneDownload;
    OneDownload=NULL;
};

void add_window_ok() {
    if (OneDownload->editor->apply_changes()) return;
    delete OneDownload->editor;
    WaitList->insert(OneDownload);
    add_download_to_clist(OneDownload);
    aa.add_download_message(OneDownload);
    OneDownload=NULL;
};


void init_add_window(...) {
    if (OneDownload) return;
    tDownload *what=OneDownload=new tDownload;
    char *temp=copy_string("ftp://somesite");
    tAddr *info=aa.analize(temp);
    what->info=info;
    if (!info->port)
        info->port=get_port_by_proto(info->protocol);
    what->SavePath=copy_string(GLOBAL_SAVE_PATH);
    what->config.timeout=TIME_OUT;
    what->config.time_for_sleep=RETRY_TIME_OUT;
    what->config.number_of_attempts=MAX_RETRIES;

    what->editor=new tDEdit;
    what->editor->init(what);
    gtk_window_set_title(GTK_WINDOW(what->editor->window),"Add new download");
    gtk_signal_connect(GTK_OBJECT(what->editor->cancel_button),"clicked",GTK_SIGNAL_FUNC(add_window_cancel), NULL);
    gtk_signal_connect(GTK_OBJECT(what->editor->ok_button),"clicked",GTK_SIGNAL_FUNC(add_window_ok),NULL);
    gtk_signal_connect(GTK_OBJECT(what->editor->window),"delete_event",GTK_SIGNAL_FUNC(add_window_cancel), NULL);
    what->editor->clear_url();
};

void init_add_clipboard_window(...) {
    if (OneDownload) return;
    init_add_window();
    tDownload *what=OneDownload;
    what->editor->paste_url();
    gtk_widget_grab_focus(what->editor->ok_button);
};
