/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
#include "gtk/gtk.h"
#include "list.h"
#include "addd.h"
#include "prefs.h"

GtkWidget *ButtonsBar;
GtkWidget *AddButton;
GtkWidget *AddClipboardButton;
GtkWidget *DelButton;
GtkWidget *StopButton;
GtkWidget *ContinueButton;
GtkWidget *DelCompleteButton;
GtkWidget *OptionsButton;
GtkWidget *LogButton;
GtkWidget *DelallButton;
GtkWidget *UpButton;
GtkWidget *DownButton;

GtkWidget *HandleBox;

GtkWidget *new_pixmap(char **xpm) {
    GdkBitmap *mask;
    GdkPixmap *pixmap;
    pixmap=make_pixmap_from_xpm(&mask,xpm);
    return (gtk_pixmap_new(pixmap,mask));
};

void del_all_downloads() {
    aa.del_all();
};

void init_buttons_bar() {
#include "pixmaps/add.xpm"
#include "pixmaps/add_clipboard.xpm"
#include "pixmaps/del.xpm"
#include "pixmaps/stop_bar.xpm"
#include "pixmaps/continue.xpm"
#include "pixmaps/del_com.xpm"
#include "pixmaps/prefs.xpm"
#include "pixmaps/openlog.xpm"
#include "pixmaps/del_all.xpm"
#include "pixmaps/up_bar.xpm"
#include "pixmaps/down_bar.xpm"

    //	HandleBox = gtk_handle_box_new ();
    ButtonsBar=gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_ICONS);
    //	gtk_container_add (GTK_CONTAINER (HandleBox), ButtonsBar);
    AddButton=gtk_toolbar_append_item (GTK_TOOLBAR (ButtonsBar), "", " Add new download ", "", new_pixmap (add_xpm),
                                       GTK_SIGNAL_FUNC (init_add_window), NULL);
    AddClipboardButton=gtk_toolbar_append_item (GTK_TOOLBAR (ButtonsBar), "", " Paste from clipboard ", "", new_pixmap (add_clipboard_xpm),
                       GTK_SIGNAL_FUNC (init_add_clipboard_window), NULL);
    DelButton=gtk_toolbar_append_item (GTK_TOOLBAR (ButtonsBar), "", " Del download ", "", new_pixmap (del_xpm),
                                       GTK_SIGNAL_FUNC (delete_download), NULL);
    gtk_toolbar_append_space (GTK_TOOLBAR (ButtonsBar));
    ContinueButton=gtk_toolbar_append_item (GTK_TOOLBAR (ButtonsBar), "", " Continue download ", "", new_pixmap (continue_xpm),
                                            GTK_SIGNAL_FUNC (continue_download), NULL);
    StopButton=gtk_toolbar_append_item (GTK_TOOLBAR (ButtonsBar), "", " Stop download ", "", new_pixmap (stop_bar_xpm),
                                        GTK_SIGNAL_FUNC (stop_download), NULL);
    DelCompleteButton=gtk_toolbar_append_item (GTK_TOOLBAR (ButtonsBar), "", " Del Completed downloads ", "", new_pixmap (del_com_xpm),
                      GTK_SIGNAL_FUNC (del_completed_downloads), NULL);
    UpButton=gtk_toolbar_append_item (GTK_TOOLBAR (ButtonsBar), "", " Move up ", "", new_pixmap (up_bar_xpm),
                                      GTK_SIGNAL_FUNC (move_download_up), NULL);
    DownButton=gtk_toolbar_append_item (GTK_TOOLBAR (ButtonsBar), "", " Move down ", "", new_pixmap (down_bar_xpm),
                                        GTK_SIGNAL_FUNC (move_download_down), NULL);
    LogButton=gtk_toolbar_append_item (GTK_TOOLBAR (ButtonsBar), "", " View log ", "", new_pixmap (openlog_xpm),
                                       GTK_SIGNAL_FUNC (open_log_for_selected), NULL);
    gtk_toolbar_append_space (GTK_TOOLBAR (ButtonsBar));
    OptionsButton=gtk_toolbar_append_item (GTK_TOOLBAR (ButtonsBar), "", " Options ", "", new_pixmap (prefs_xpm),
                                           GTK_SIGNAL_FUNC (init_options_window), NULL);
    gtk_toolbar_append_space (GTK_TOOLBAR (ButtonsBar));
    gtk_toolbar_append_space (GTK_TOOLBAR (ButtonsBar));
    gtk_toolbar_append_space (GTK_TOOLBAR (ButtonsBar));
    DelallButton=gtk_toolbar_append_item (GTK_TOOLBAR (ButtonsBar), "", " Delete all downloads ", "", new_pixmap (del_all_xpm),
                                          GTK_SIGNAL_FUNC (del_all_downloads), NULL);
};

