/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <stdio.h>
#include "edit.h"
#include "list.h"
#include "../history.h"
#include "../var.h"
#include "../locstr.h"
#include "../main.h"

extern tMain aa;
void edit_window_cancel(GtkWidget *parent,tDEdit *where);
void edit_window_delete(GtkObject *parent);
void edit_window_ok(GtkWidget *which,tDEdit *where);

tHistory *UrlHistory=NULL;
tHistory *PathHistory=NULL;

GList *make_glist_from_mylist(tHistory *parent) {
    GList *rvalue=NULL;
    tString *tmp=parent->last();
    while (tmp) {
        rvalue = g_list_append (rvalue, tmp->body);
        tmp=parent->next();
    };
    return rvalue;
};
/******************************************************/
void init_edit_window(tDownload *what) {
    if (!what || what->editor || what->owner==DL_RUN) return;
    what->editor=new tDEdit;
    what->editor->init(what);
    gtk_window_set_title(GTK_WINDOW(what->editor->window),"Edit download");
    gtk_signal_connect(GTK_OBJECT(what->editor->cancel_button),"clicked",GTK_SIGNAL_FUNC(edit_window_cancel),what->editor);
    gtk_signal_connect(GTK_OBJECT(what->editor->ok_button),"clicked",GTK_SIGNAL_FUNC(edit_window_ok),what->editor);
    gtk_signal_connect(GTK_OBJECT(what->editor->window),"delete_event",GTK_SIGNAL_FUNC(edit_window_delete), what->editor);
};

void edit_window_cancel(GtkWidget *parent,tDEdit *where) {
    delete where;
};

void edit_window_delete(GtkObject *parent) {
    tDEdit *tmp=(tDEdit *)gtk_object_get_user_data(parent);
    delete tmp;
};

void edit_window_ok(GtkWidget *which,tDEdit *where) {
    if (where->apply_changes()) return;
    delete where;
};

void edit_browser_open(GtkWidget *parent,tDEdit *where) {
    where->init_browser();
};

void edit_browser_ok(GtkWidget *parent,tDEdit *where) {
    where->browser_ok();
};

void edit_browser_cancel(GtkWidget *parent,tDEdit *where) {
    where->done_browser();
};

void edit_browser_delete(GtkObject *parent) {
    tDEdit *tmp=(tDEdit *)gtk_object_get_user_data(parent);
    tmp->done_browser();
};

void edit_window_password(GtkWidget *parent,tDEdit *where) {
    where->setup_entries();
};
/******************************************************/

tDEdit::tDEdit() {
    parent=NULL;
    window=NULL;
    dir_browser=NULL;
};
void tDEdit::init(tDownload *who) {
    if (!who) return;
    parent=who;
    window=gtk_window_new(GTK_WINDOW_DIALOG);
    gtk_container_border_width(GTK_CONTAINER(window),5);
    gtk_window_set_position(GTK_WINDOW(window),GTK_WIN_POS_CENTER);
    gtk_window_set_policy (GTK_WINDOW(window), FALSE,FALSE,FALSE);
    gtk_widget_set_usize(window,470,255);
    gtk_object_set_user_data(GTK_OBJECT(window),this);
    GtkWidget *notebook=gtk_notebook_new();

    /* initing entries
     */
    user_entry=gtk_entry_new_with_max_length(9);
    pass_entry=gtk_entry_new_with_max_length(MAX_LEN);
    path_entry=gtk_combo_new();
    url_entry=gtk_combo_new();

    gtk_widget_set_usize(GTK_COMBO(path_entry)->entry,370,-1);
    gtk_widget_set_usize(GTK_COMBO(url_entry)->entry,391,-1);
    gtk_widget_set_usize(pass_entry,100,-1);
    gtk_widget_set_usize(user_entry,100,-1);
    GList *UrlList=make_glist_from_mylist(UrlHistory);
    GList *PathList=make_glist_from_mylist(PathHistory);
    if (UrlList)
        gtk_combo_set_popdown_strings (GTK_COMBO (url_entry), UrlList);
    if (PathList)
        gtk_combo_set_popdown_strings (GTK_COMBO (path_entry), PathList);
    char temp[MAX_LEN];
    make_url_from_download(who,temp);
    gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(url_entry)->entry),temp);
    gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(path_entry)->entry),who->SavePath);
    if (who->info->pass)
        gtk_entry_set_text(GTK_ENTRY(pass_entry),who->info->pass);
    if (who->info->username)
        gtk_entry_set_text(GTK_ENTRY(user_entry),who->info->username);
    gtk_entry_set_visibility(GTK_ENTRY(pass_entry),FALSE);
    /* initing labels
     */
    GtkWidget *url_label=gtk_label_new("URL:");
    GtkWidget *path_label=gtk_label_new("Save download to folder");
    GtkWidget *pass_label=gtk_label_new("password");
    GtkWidget *user_label=gtk_label_new("user name");
    /* initing boxes
     */
    GtkWidget *url_box=gtk_hbox_new(FALSE,0);
    GtkWidget *path_box=gtk_hbox_new(FALSE,0);
    GtkWidget *path_vbox=gtk_vbox_new(FALSE,0);
    GtkWidget *pass_box=gtk_hbox_new(FALSE,0);
    GtkWidget *user_box=gtk_hbox_new(FALSE,0);
    GtkWidget *dir_browser_button=gtk_button_new_with_label("Browse");
    gtk_signal_connect(GTK_OBJECT(dir_browser_button),"clicked",GTK_SIGNAL_FUNC(edit_browser_open),this);
    gtk_box_set_spacing(GTK_BOX(url_box),5);
    gtk_box_set_spacing(GTK_BOX(path_box),5);
    gtk_box_set_spacing(GTK_BOX(path_vbox),2);
    gtk_box_set_spacing(GTK_BOX(user_box),5);
    gtk_box_set_spacing(GTK_BOX(pass_box),5);
    gtk_box_pack_start(GTK_BOX(url_box),url_label,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(url_box),url_entry,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(path_vbox),path_label,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(path_box),path_entry,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(path_box),dir_browser_button,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(path_vbox),path_box,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(pass_box),pass_entry,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(pass_box),pass_label,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(user_box),user_entry,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(user_box),user_label,FALSE,FALSE,0);

    button=gtk_check_button_new_with_label("Use passwor for this site");
    gtk_signal_connect(GTK_OBJECT(button),"clicked",GTK_SIGNAL_FUNC(edit_window_password),this);
    if (who->info->username)
        GTK_TOGGLE_BUTTON(button)->active=TRUE;
    else
        GTK_TOGGLE_BUTTON(button)->active=FALSE;
    /* initing buttons
     */
    GtkWidget *buttons_hbox=gtk_hbutton_box_new();
    gtk_button_box_set_layout(GTK_BUTTON_BOX(buttons_hbox),GTK_BUTTONBOX_END);
    gtk_button_box_set_spacing(GTK_BUTTON_BOX(buttons_hbox),5);
    ok_button=gtk_button_new_with_label("Ok");
    cancel_button=gtk_button_new_with_label("Cancel");
    GTK_WIDGET_SET_FLAGS(ok_button,GTK_CAN_DEFAULT);
    GTK_WIDGET_SET_FLAGS(cancel_button,GTK_CAN_DEFAULT);
    gtk_box_pack_start(GTK_BOX(buttons_hbox),ok_button,TRUE,TRUE,0);
    gtk_box_pack_start(GTK_BOX(buttons_hbox),cancel_button,TRUE,TRUE,0);

    /* initing other
     */
    GtkWidget *other_vbox=gtk_vbox_new(FALSE,0);
    timeout_entry=gtk_entry_new_with_max_length(3);
    sleep_entry=gtk_entry_new_with_max_length(3);
    attempts_entry=gtk_entry_new_with_max_length(3);
    sprintf(temp,"%i",who->config.timeout);
    gtk_entry_set_text(GTK_ENTRY(timeout_entry),temp);
    sprintf(temp,"%i",who->config.time_for_sleep);
    gtk_entry_set_text(GTK_ENTRY(sleep_entry),temp);
    sprintf(temp,"%i",who->config.number_of_attempts);
    gtk_entry_set_text(GTK_ENTRY(attempts_entry),temp);
    gtk_widget_set_usize(timeout_entry,30,-1);
    gtk_widget_set_usize(attempts_entry,30,-1);
    gtk_widget_set_usize(sleep_entry,30,-1);

    GtkWidget *other_hbox=gtk_hbox_new(FALSE,0);
    gtk_box_set_spacing(GTK_BOX(other_hbox),5);
    GtkWidget *other_label=gtk_label_new("timeout when reading frrom socket");
    gtk_box_pack_start(GTK_BOX(other_hbox),timeout_entry,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(other_hbox),other_label,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(other_vbox),other_hbox,FALSE,FALSE,0);

    other_hbox=gtk_hbox_new(FALSE,0);
    gtk_box_set_spacing(GTK_BOX(other_hbox),5);
    other_label=gtk_label_new("seconds sleep after reconnect");
    gtk_box_pack_start(GTK_BOX(other_hbox),sleep_entry,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(other_hbox),other_label,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(other_vbox),other_hbox,FALSE,FALSE,0);

    other_hbox=gtk_hbox_new(FALSE,0);
    gtk_box_set_spacing(GTK_BOX(other_hbox),5);
    other_label=gtk_label_new("amount of attempts");
    gtk_box_pack_start(GTK_BOX(other_hbox),attempts_entry,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(other_hbox),other_label,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(other_vbox),other_hbox,FALSE,FALSE,0);
    GtkWidget *other_frame=gtk_frame_new("Other");
    gtk_container_border_width(GTK_CONTAINER(other_frame),5);
    gtk_container_add(GTK_CONTAINER(other_frame),other_vbox);

    /* initing window
     */
    GtkWidget *vbox=gtk_vbox_new(FALSE,0);
    GtkWidget *vbox2=gtk_vbox_new(FALSE,0);
    gtk_box_set_spacing(GTK_BOX(vbox),5);
    gtk_box_set_spacing(GTK_BOX(vbox2),5);
    gtk_box_pack_start(GTK_BOX(vbox),url_box,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(vbox),path_vbox,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(vbox),button,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(vbox),user_box,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(vbox),pass_box,FALSE,FALSE,0);
    GtkWidget *frame=gtk_frame_new("Download");
    gtk_container_border_width(GTK_CONTAINER(frame),5);
    gtk_container_add(GTK_CONTAINER(frame),vbox);
    gtk_notebook_append_page(GTK_NOTEBOOK(notebook),frame,gtk_label_new("Main"));
    gtk_notebook_append_page(GTK_NOTEBOOK(notebook),other_frame,gtk_label_new("Other"));
    gtk_box_pack_start(GTK_BOX(vbox2),notebook,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(vbox2),buttons_hbox,FALSE,FALSE,0);
    gtk_container_add(GTK_CONTAINER(window),vbox2);
    gtk_window_set_default(GTK_WINDOW(window),ok_button);
    gtk_widget_show_all(window);
    gtk_widget_grab_focus(GTK_COMBO(url_entry)->entry);
    setup_entries();
};


void tDEdit::init_browser() {
    if (dir_browser) return;
    dir_browser=gtk_file_selection_new("Select directory");
    gtk_object_set_user_data(GTK_OBJECT(dir_browser),this);
    gtk_widget_set_sensitive(GTK_FILE_SELECTION(dir_browser)->file_list,FALSE);
    char *tmp=gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(path_entry)->entry));
    if (tmp && *tmp)
        gtk_file_selection_set_filename(GTK_FILE_SELECTION(dir_browser),tmp);
    gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(dir_browser)->ok_button),
                       "clicked",GTK_SIGNAL_FUNC(edit_browser_ok),this);
    gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(dir_browser)->cancel_button),
                       "clicked",GTK_SIGNAL_FUNC(edit_browser_cancel),this);
    gtk_signal_connect(GTK_OBJECT(&(GTK_FILE_SELECTION(dir_browser)->window)),
                       "delete_event",GTK_SIGNAL_FUNC(edit_browser_delete),this);
    gtk_widget_show(dir_browser);
};

void tDEdit::browser_ok() {
    if (!dir_browser) return;
    char *tmp;
    tmp=gtk_file_selection_get_filename(GTK_FILE_SELECTION(dir_browser));
    gtk_entry_set_text(GTK_ENTRY(GTK_ENTRY(GTK_COMBO(path_entry)->entry)),tmp);
    gtk_widget_destroy(dir_browser);
    dir_browser=NULL;
};

void tDEdit::done_browser() {
    if (!dir_browser) return;
    gtk_widget_destroy(dir_browser);
    dir_browser=NULL;
};

int tDEdit::apply_changes() {
    char *temp=copy_string(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(url_entry)->entry)));
    del_crlf(temp);
    tAddr *addr=aa.analize(temp);
    if (!addr) return 1;
    delete (parent->info);
    parent->info=addr;
    if (parent->info->username && parent->info->pass)
        GTK_TOGGLE_BUTTON(button)->active=TRUE;
    if (GTK_TOGGLE_BUTTON(button)->active){
    	if (strlen(gtk_entry_get_text(GTK_ENTRY(user_entry))) &&gtk_entry_get_text(GTK_ENTRY(pass_entry))){
		    if (parent->info->pass) delete(parent->info->pass);
    		if (parent->info->username) delete(parent->info->username);
        	parent->info->username=copy_string(gtk_entry_get_text(GTK_ENTRY(user_entry)));
        	parent->info->pass=copy_string(gtk_entry_get_text(GTK_ENTRY(pass_entry)));
       	};
    }else {
        parent->info->pass=NULL;
        parent->info->username=NULL;
    };
    if (parent->info->port==0)
        parent->info->port=get_port_by_proto(parent->info->protocol);
    delete (parent->SavePath);
    parent->SavePath=copy_string(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(path_entry)->entry)));
    parent->FileType=parent->status=0;
    parent->FullSize=-1;
    /* change histories
     */
    char *URL=make_simply_url(parent);
    PathHistory->add(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(path_entry)->entry)));
    UrlHistory->add(URL);
    /*change data in list if available
     */
    if (parent->GTKCListRow > 0) {
        change_clist_data(parent->GTKCListRow,URL_COL,URL);
        change_clist_data(parent->GTKCListRow,FILE_COL,parent->info->file);
        for (int i=FILE_TYPE_COL;i<URL_COL;i++)
            change_clist_data(parent->GTKCListRow,i,"");
    };
    delete URL;
    int  temp1=0;
    sscanf(gtk_entry_get_text(GTK_ENTRY(timeout_entry)),"%u",&temp1);
    if (temp1>0 && temp1<1000) parent->config.timeout=temp1;
    sscanf(gtk_entry_get_text(GTK_ENTRY(sleep_entry)),"%u",&temp1);
    if (temp1>=0 && temp1<1000) parent->config.time_for_sleep=temp1;
    sscanf(gtk_entry_get_text(GTK_ENTRY(attempts_entry)),"%u",&temp1);
    if (temp1>=0) parent->config.number_of_attempts=temp1;
    return 0;
};

void tDEdit::setup_entries() {
    gtk_entry_set_editable(GTK_ENTRY(pass_entry),GTK_TOGGLE_BUTTON(button)->active);
    gtk_entry_set_editable(GTK_ENTRY(user_entry),GTK_TOGGLE_BUTTON(button)->active);
    gtk_widget_set_sensitive(user_entry,GTK_TOGGLE_BUTTON(button)->active);
    gtk_widget_set_sensitive(pass_entry,GTK_TOGGLE_BUTTON(button)->active);
};

void tDEdit::paste_url() {
    gtk_editable_paste_clipboard(GTK_EDITABLE(GTK_COMBO(url_entry)->entry));
};

void tDEdit::select_url() {
    gtk_entry_select_region(GTK_ENTRY(GTK_COMBO(url_entry)->entry),0,strlen(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(url_entry)->entry))));
};

void tDEdit::clear_url() {
    gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(url_entry)->entry),"");
};

void tDEdit::done() {
    if (parent) parent->editor=NULL;
    gtk_widget_destroy(window);
    done_browser();
};

tDEdit::~tDEdit() {
    done();
};
