/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <gtk/gtk.h>
#include <string.h>
#include "list.h"
#include "../main.h"
#include "../var.h"
guchar graph_rgb_data[100*16*4];
static GdkRgbCmap *cmap;

void draw_graph() {
    guint32 colors[3];
    colors[0]=0x000000;
    colors[1]=0x323232;
    colors[2]=0xFFFFFF;
    int XSize=2*(METER_LENGTH-1);
    int YSize=16;
    int WX,WY;
    gdk_window_get_size(MainWindow->window,&WX,&WY);
    gdk_draw_indexed_image(MainWindow->window,MainWindowGC,WX-3-XSize,WY-2-YSize,XSize,YSize,
                           GDK_RGB_DITHER_NONE,(guchar *)graph_rgb_data,XSize,cmap);
    gdk_flush();
};

void recalc_graph() {
    if (!GlobalMeter) return;
    guint32 colors[3];
    colors[0]=0x000000;
    colors[1]=0x323232;
    colors[2]=0xFFFFFF;
    int XSize=2*(METER_LENGTH-1);
    int YSize=16;
    int WX,WY;
    gdk_window_get_size(MainWindow->window,&WX,&WY);
    memset(graph_rgb_data,2,XSize*YSize);

    int MAX=GlobalMeter->max();
    int NUM=GlobalMeter->count();
    if (NUM>XSize) NUM=XSize;
    if (MAX>0) {
        int value=(YSize*GlobalMeter->last_value())/MAX;
        for (int x=XSize-1;x>=0;x-=2) {
            for (int y=YSize-1;y>=(YSize-value);y--) {
                graph_rgb_data[y*XSize+x]=0;
                graph_rgb_data[y*XSize+x-1]=0;
            };
            value=(YSize*GlobalMeter->next_value())/MAX;
        };
    };
};

void init_graph() {
    guint32 colors[3];
    colors[0]=0;
    colors[1]=0x323232;
    colors[2]=0xFFFFFF;
    int XSize=2*(METER_LENGTH-1);
    int YSize=16;
    int WX,WY;
    gdk_window_get_size(MainWindow->window,&WX,&WY);

    cmap=gdk_rgb_cmap_new(colors,3);
    memset(graph_rgb_data,2,XSize*YSize);
    gdk_window_clear_area(MainWindow->window,WX-3-XSize,WY-3-YSize,XSize,YSize);
    gdk_draw_indexed_image(MainWindow->window,MainWindowGC,WX-3-XSize,WY-2-YSize,XSize,YSize,
                           GDK_RGB_DITHER_NONE,(guchar *)graph_rgb_data,XSize,cmap);
    gdk_flush();
};
