/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <stdio.h>
#include <pthread.h>
#include <string.h>

#include "../dlist.h"
#include "../main.h"
#include "../var.h"
#include "../savelog.h"
#include "../config.h"
#include "../locstr.h"

#include "log.h"
#include "addd.h"
#include "list.h"
#include "prefs.h"
#include "buttons.h"
#include "about.h"
#include "graph.h"
#include "edit.h"
#include "lmenu.h"

GtkWidget *MainMenu;
GtkWidget *ListOfDownloads;
GtkAdjustment *ProgressBarValues;
GtkWidget *ProgressOfDownload;
GtkWidget *MainStatusBar,*ReadedBytesStatusBar;
GtkWidget *MainWindow=NULL;
GtkWidget *MainHBox;
GdkGC *MainWindowGC;
GtkWidget *ContainerForCList;
GtkWidget *BoxForGraph;
GtkWidget *MainLogList;

GdkBitmap *wait_mask,*stop_mask,*pause_mask,*complete_mask,*run_mask,*part_run_mask;
GdkPixmap *wait_pixmap=NULL,*stop_pixmap=NULL,*pause_pixmap=NULL,*complete_pixmap=NULL;
GdkPixmap *run_pixmap=NULL,*part_run_pixmap=NULL;

GtkItemFactory *list_menu_itemfact;

gint StatusBarContext,RBStatusBarContext;
gint SelectedRow;
int MainTimer,LogsTimer,GraphTimer,ClipboardTimer;
pthread_mutex_t MAIN_GTK_MUTEX=PTHREAD_MUTEX_INITIALIZER;

int FirstConfigureEvent;
gint SizeListOfDownloads;
gint ListColumns=12;
gchar *ListTitles[] = {"","File","Type","Full Size","Downloaded","%","Speed","Time","Remaining","Pause","Attempt","URL"};
gint ColumnSizes[]={25,100,40,70,70,30,60,60,60,40,40,500};

/******************************************************************
    This part of code for DnD (Drag-n-Drop) support added by
		     Justin Bradford
 ******************************************************************/

// for drag-drop support

// drop handler
static void list_dnd_drop_internal(GtkWidget *widget, GdkDragContext *context,
                                   gint x, gint y, GtkSelectionData *selection_data, guint info, guint time);

// enum for easy reference to our support mime-types
// (this will make sense when more types (like uri-list are supported)
enum {
      TARGET_URL
     };

// define a target entry listing the mime-types we'll acknowledge
static GtkTargetEntry download_drop_types[] = {
    { "x-url/http",    0, TARGET_URL},
    { "x-url/ftp",     0, TARGET_URL},
    { "_NETSCAPE_URL", 0, TARGET_URL}
};

// calculate the number of mime-types listed
static gint n_download_drop_types = sizeof(download_drop_types) / sizeof(download_drop_types[0]);

/*********************************************************************
    End of first part of DnD's code
 *********************************************************************/

void util_item_factory_popup(GtkItemFactory *ifactory,guint x, guint y,guint mouse_button,guint32 time) {
    
    
    static GQuark quark_user_menu_pos=0;
    struct Pos {gint x;gint y;} *pos;
    
    if(!quark_user_menu_pos)
        quark_user_menu_pos=g_quark_from_static_string("user_menu_pos");
    
    pos=(Pos *)gtk_object_get_data_by_id(GTK_OBJECT(ifactory),quark_user_menu_pos);
    if(!pos) {
        
        
        pos=(Pos *)g_malloc0(sizeof(struct Pos));
        gtk_object_set_data_by_id_full(GTK_OBJECT(ifactory->widget),quark_user_menu_pos,pos,g_free);
    }
    pos->x=x;
    pos->y=y;
    
    gtk_menu_popup(GTK_MENU(ifactory->widget),NULL,NULL,NULL,pos,mouse_button,time);
};

void init_main_menu() {
    
    
    GtkItemFactoryEntry menu_items[] = {
        {"/_File",         NULL,         NULL, 0, "<Branch>"},
        {"/File/_New Download",     "<control>N", init_add_window, 0, NULL},
        {"/File/_Paste Download", "<control>P", init_add_clipboard_window, 0, NULL},
        {"/File/sep1",     NULL,         NULL, 0, "<Separator>"},
        {"/File/Exit",     "<alt>X", my_main_quit, 0, NULL},
        {"/_Download",      NULL,         NULL, 0, "<Branch>"},
        {"/Download/View _Log",  NULL,  open_log_for_selected, 0, NULL},
        {"/Download/_Stop download",  "<alt>S",  stop_download, 0, NULL},
        {"/Download/Edit download", "<alt>E",  open_edit_for_selected,	0, NULL},
        {"/Download/_Delete download","<alt>C",  delete_download, 0, NULL},
        {"/Download/Continue download",  NULL,  continue_download, 0, NULL},
        {"/Download/Del completed",  NULL,  del_completed_downloads, 0, NULL},
        {"/Download/Del fataled",  NULL,  del_fataled_downloads, 0, NULL},
        {"/_Options",      NULL,         NULL, 0, "<Branch>"},
        {"/Options/Common",  NULL,       init_options_window, 0, NULL},
        {"/_Help",         NULL,         NULL, 0, "<LastBranch>"},
        {"/_Help/About",   NULL,         init_about_window, 0, NULL},
    };
    int nmenu_items = sizeof(menu_items) / sizeof(menu_items[0]);
    GtkItemFactory *item_factory;
    GtkAccelGroup *accel_group;
    
    accel_group = gtk_accel_group_new();
    item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>",accel_group);
    gtk_item_factory_create_items(item_factory, nmenu_items, menu_items, NULL);
    MainMenu= gtk_item_factory_get_widget(item_factory, "<main>");
    gtk_accel_group_attach(accel_group,GTK_OBJECT(MainWindow));
};

void my_main_quit(...) {
    
    
    gtk_timeout_remove(MainTimer);
    gtk_timeout_remove(LogsTimer);
    gtk_timeout_remove(GraphTimer);
    save_list();
    save_config();
    aa.done();
    gtk_main_quit();
};

void open_log_for_selected(...) {
    
    
    tDownload *temp=(tDownload *)gtk_clist_get_row_data(
                    GTK_CLIST(ListOfDownloads),SelectedRow);
    init_log_window(temp);
};

void open_edit_for_selected(...) {
    
    
    tDownload *temp=(tDownload *)gtk_clist_get_row_data(
                    GTK_CLIST(ListOfDownloads),SelectedRow);
    init_edit_window(temp);
};

void del_completed_downloads(...) {
    
    
    DEL_COMPLETED=1;
};

void del_fataled_downloads(...) {
    
    
    DEL_FATALED=1;
};

void stop_download(...) {
    
    
    tDownload *temp=(tDownload *)gtk_clist_get_row_data(
                    GTK_CLIST(ListOfDownloads),SelectedRow);
    aa.stop_download(temp);
};

void delete_download(...) {
    
    
    tDownload *temp=(tDownload *)gtk_clist_get_row_data(
                    GTK_CLIST(ListOfDownloads),SelectedRow);
    aa.delete_download(temp);
};

void continue_download(...) {
    
    
    tDownload *temp=(tDownload *)gtk_clist_get_row_data(
                    GTK_CLIST(ListOfDownloads),SelectedRow);
    aa.continue_download(temp);
};
/* ******************************************************************** */
void select_download(GtkWidget *clist, gint row, gint column,
                     GdkEventButton *event, gpointer data,gpointer nothing) {
    
    
    SelectedRow=row;
    update_progress_bar();
    gtk_statusbar_pop(GTK_STATUSBAR(MainStatusBar),StatusBarContext);
    tDownload *temp=(tDownload *)gtk_clist_get_row_data(
                    GTK_CLIST(ListOfDownloads),SelectedRow);
    if (temp)
        gtk_statusbar_push(GTK_STATUSBAR(MainStatusBar),StatusBarContext,temp->info->file);
    else
        gtk_statusbar_push(GTK_STATUSBAR(MainStatusBar),StatusBarContext,"");
    if (event && event->type==GDK_2BUTTON_PRESS && event->button==1)
        open_log_for_selected();
};

int list_event_callback(GtkWidget *widget,GdkEvent *event) {
    
    
    if (event->type == GDK_BUTTON_PRESS) {
        
        GdkEventButton *bevent=(GdkEventButton *)event;
        if (bevent->button==3) {
            int row;
            gtk_clist_unselect_all(GTK_CLIST(widget));
            SelectedRow=-1;
            if (gtk_clist_get_selection_info(GTK_CLIST(widget),int(bevent->x),int(bevent->y),&row,NULL)) {
                gtk_clist_select_row(GTK_CLIST(widget),row,-1);
            };	
            gint x,y;
            GdkModifierType modmask;
            gdk_window_get_pointer(NULL,&x,&y, &modmask);
            //          util_item_factory_popup(list_menu_itemfact,x,y,3,GDK_CURRENT_TIME);
            list_menu_prepare();
            gtk_menu_popup(GTK_MENU(ListMenu),NULL,NULL,NULL,NULL,bevent->button,bevent->time);            
            return TRUE;
        };
    };
    if (event->type == GDK_KEY_PRESS) {
        
        GdkEventKey *kevent=(GdkEventKey *)event;
        if (kevent->state & GDK_SHIFT_MASK) {
            
            switch (kevent->keyval) {
                    
                case GDK_KP_Up:
                case GDK_Up: {
                        
                        move_download_up();
                        return TRUE;
                    };
                case GDK_KP_Down:
                case GDK_Down: {
                        
                        move_download_down();
                        return TRUE;
                    };
                default: break;
            };
        };
    };
    return FALSE;
};

/**********************************************************
    Handler for DnD event
 **********************************************************/
// this the drag-drop even handler
// just add the url, and assume default download location
static void list_dnd_drop_internal(GtkWidget *widget,
                                   GdkDragContext *context,
                                   gint x, gint y,
                                   GtkSelectionData *selection_data,
                                   guint info, guint time) {
    
    
    g_return_if_fail(widget!=NULL);
    
    switch (info) {
            
            
            // covers all single URLs
            // a uri-list mime-type will need special handling
        case TARGET_URL: {
                
                
                // make sure our url (in selection_data->data) is good
                if (selection_data->data != NULL) {
                    
                    
                    int len = strlen((char*)selection_data->data);
                    if (len && selection_data->data[len-1] == '\n')
                        selection_data->data[len-1] = 0;
                    // add the new download
                    aa.add_downloading((char*)selection_data->data, (char*)GLOBAL_SAVE_PATH);
                }
            }
    }
}

/**********************************************************
    End of handler for DnD 
 **********************************************************/

void init_view_list() {
    
    
    ListOfDownloads = gtk_clist_new_with_titles( ListColumns, ListTitles);
    gtk_signal_connect(GTK_OBJECT(ListOfDownloads), "select_row",
                       GTK_SIGNAL_FUNC(select_download),NULL);
    gtk_signal_connect(GTK_OBJECT(ListOfDownloads), "event",
                       GTK_SIGNAL_FUNC(list_event_callback),NULL);
    
    gtk_clist_set_row_height(GTK_CLIST(ListOfDownloads),16);
    for(int i=0;i<ListColumns;i++)
        gtk_clist_set_column_width (GTK_CLIST(ListOfDownloads),i,ColumnSizes[i]);
    gtk_clist_set_shadow_type (GTK_CLIST(ListOfDownloads), GTK_SHADOW_IN);
    ContainerForCList=gtk_scrolled_window_new(NULL,NULL);
    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (ContainerForCList),
                                    GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
    
    /****************************************************************
      Initing signals' handlers for DnD support (added by Justin Bradford)
     ****************************************************************/
    // connect the drag-drop signal
    gtk_signal_connect(GTK_OBJECT(ContainerForCList),
                       "drag_data_received",
                       GTK_SIGNAL_FUNC(list_dnd_drop_internal),
                       NULL);
    // set the list container as a drop destination
    gtk_drag_dest_set(GTK_WIDGET(ContainerForCList),
                      (GtkDestDefaults)(GTK_DEST_DEFAULT_MOTION |
                                        GTK_DEST_DEFAULT_HIGHLIGHT |
                                        GTK_DEST_DEFAULT_DROP),
                      download_drop_types, n_download_drop_types,
                      (GdkDragAction)GDK_ACTION_COPY);
    
    /****************************************************************
        End of second part of DnD code
     ****************************************************************/
    
    gtk_clist_set_hadjustment(GTK_CLIST(ListOfDownloads),NULL);
    gtk_clist_set_vadjustment(GTK_CLIST(ListOfDownloads),NULL);
    gtk_clist_set_column_justification (GTK_CLIST (ListOfDownloads), FULL_SIZE_COL, GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_justification (GTK_CLIST (ListOfDownloads), PERCENT_COL, GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_justification (GTK_CLIST (ListOfDownloads), DOWNLOADED_SIZE_COL, GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_justification (GTK_CLIST (ListOfDownloads), TREAT_COL, GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_justification (GTK_CLIST (ListOfDownloads), SPEED_COL, GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_justification (GTK_CLIST (ListOfDownloads), ELAPSED_TIME_COL, GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_justification (GTK_CLIST (ListOfDownloads), TIME_COL, GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_justification (GTK_CLIST (ListOfDownloads), PAUSE_COL, GTK_JUSTIFY_RIGHT);
    gtk_widget_show(ListOfDownloads);
    gtk_container_add(GTK_CONTAINER(ContainerForCList),ListOfDownloads);
};

void add_download_to_clist(tDownload *what) {
    
    
    gchar *data[ListColumns];
    char *temp;
    char *URL=make_simply_url(what);
    for (int i=0;i<ListColumns;i++)
        data[i]=NULL;
    temp=what->info->file;
    data[URL_COL]=URL;
    data[FILE_COL]=temp;
    what->GTKCListRow=gtk_clist_append(GTK_CLIST(ListOfDownloads),data);
    gtk_clist_set_row_data(GTK_CLIST(ListOfDownloads),what->GTKCListRow,gpointer(what));
    SizeListOfDownloads+=1;
    set_pixmap_wait(what->GTKCListRow);
    delete URL;
};

GdkPixmap *make_pixmap_from_xpm(GdkBitmap **mask,char **xpm,GtkWidget *parent) {
    
    
    GtkStyle *style=gtk_widget_get_style(MainWindow);
    GdkPixmap *pixmap=gdk_pixmap_create_from_xpm_d (parent->window,
                      mask,&style->bg[GTK_STATE_NORMAL] , xpm);
    GdkColormap *colormap = gtk_widget_get_colormap (MainWindow);
    GdkColor wait_color={0,0,0,0};
    gdk_color_alloc (colormap, &wait_color);
    return pixmap;
};

GdkPixmap *make_pixmap_from_xpm(GdkBitmap **mask,char **xpm) {
    
    
    return make_pixmap_from_xpm(mask,xpm,MainWindow);
};

void set_pixmap_wait(int row) {
    
    
#include "pixmaps/wait_xpm.xpm"
    if (!wait_pixmap)
        wait_pixmap=make_pixmap_from_xpm(&wait_mask,wait_xpm);
    gtk_clist_set_pixmap (GTK_CLIST (ListOfDownloads), row,
                          STATUS_COL, wait_pixmap, wait_mask);
};

void set_pixmap_run(int row) {
    
    
#include "pixmaps/run_xpm.xpm"
    if (!run_pixmap)
        run_pixmap=make_pixmap_from_xpm(&run_mask,run_xpm);
    gtk_clist_set_pixmap (GTK_CLIST (ListOfDownloads), row,
                          STATUS_COL, run_pixmap, run_mask);
};

void set_pixmap_part_run(int row) {
#include "pixmaps/run_part.xpm"
    if (!part_run_pixmap)
        part_run_pixmap=make_pixmap_from_xpm(&part_run_mask,run_part_xpm);
    gtk_clist_set_pixmap (GTK_CLIST (ListOfDownloads), row,
                          STATUS_COL, part_run_pixmap, part_run_mask);
};


void set_pixmap_stop(int row) {
    
    
#include "pixmaps/stop_xpm.xpm"
    if (!stop_pixmap)
        stop_pixmap=make_pixmap_from_xpm(&stop_mask,stop_xpm);
    gtk_clist_set_pixmap (GTK_CLIST (ListOfDownloads), row,
                          STATUS_COL, stop_pixmap, stop_mask);
};

void set_pixmap_pause(int row) {
    
    
#include "pixmaps/paused.xpm"
    if (!pause_pixmap)
        pause_pixmap=make_pixmap_from_xpm(&pause_mask,paused_xpm);
    gtk_clist_set_pixmap (GTK_CLIST (ListOfDownloads), row,
                          STATUS_COL, pause_pixmap, pause_mask);
};

void set_pixmap_complete(int row) {
    
    
#include "pixmaps/complete.xpm"
    if (!complete_pixmap)
        complete_pixmap=make_pixmap_from_xpm(&complete_mask,complete_xpm);
    gtk_clist_set_pixmap (GTK_CLIST (ListOfDownloads), row,
                          STATUS_COL, complete_pixmap, complete_mask);
};

void change_clist_data(int row,int column,gchar *data) {
    
    
    gtk_clist_set_text(GTK_CLIST(ListOfDownloads),row,column,data);
};


void del_download_from_clist(tDownload *what) {
    
    
    gtk_clist_remove(GTK_CLIST(ListOfDownloads),what->GTKCListRow);
    SizeListOfDownloads-=1;
    if (SelectedRow>what->GTKCListRow) SelectedRow-=1;
    for (int i=what->GTKCListRow;i<SizeListOfDownloads;i++) {
        
        
        tDownload *temp=(tDownload *)gtk_clist_get_row_data(
                        GTK_CLIST(ListOfDownloads),i);
        if (temp) temp->GTKCListRow=i;
    };
};

tDownload *get_download_from_clist(int row) {
    
    
    tDownload *what=(tDownload *)gtk_clist_get_row_data(GTK_CLIST(ListOfDownloads),row);
    return what;
};

void freeze_clist() {
    
    
    gtk_clist_freeze(GTK_CLIST(ListOfDownloads));
};

void unfreeze_clist() {
    
    
    gtk_clist_thaw(GTK_CLIST(ListOfDownloads));
    gtk_widget_show(ListOfDownloads);
};

void insert_to_clist_with_data(tDownload *what,int row) {
    
    
    gchar *data[ListColumns];
    for (int i=0;i<=ListColumns;i++)
        data[i]=NULL;
    gtk_clist_insert(GTK_CLIST(ListOfDownloads),row,data);
    gtk_clist_set_row_data(GTK_CLIST(ListOfDownloads),row,what);
    switch (what->owner) {
        case DL_WAIT: {
                set_pixmap_wait(row);
                break;
            };
        case DL_STOP: {
                set_pixmap_stop(row);
                break;
            };
        case DL_RUN: {
                set_pixmap_run(row);
                break;
            };
        case DL_PAUSE: {
                set_pixmap_pause(row);
                break;
            };
        case DL_COMPLETE:
            set_pixmap_complete(row);
    };
};

void move_download_up() {
    int row=SelectedRow;
    if (row<=0) return;
    tDownload *what=(tDownload *)gtk_clist_get_row_data(GTK_CLIST(ListOfDownloads),row);
    if (!what) return;
    freeze_clist();
    insert_to_clist_with_data(what,row-1);
    what->GTKCListRow=row-1;
    char *text;
    for (int i=1;i<=URL_COL;i++) {
        
        
        text=NULL;
        gtk_clist_get_text(GTK_CLIST(ListOfDownloads),row+1,i,&text);
        gtk_clist_set_text(GTK_CLIST(ListOfDownloads),row-1,i,text);
    };
    gtk_clist_remove(GTK_CLIST(ListOfDownloads),row+1);
    
    tDownload *what2=(tDownload *)gtk_clist_get_row_data(GTK_CLIST(ListOfDownloads),row);
    what2->GTKCListRow=row;
    SelectedRow-=1;
    gtk_clist_select_row(GTK_CLIST(ListOfDownloads),SelectedRow,0);
    if (WaitList->owner(what)) WaitList->forward(what);
    unfreeze_clist();
};

void move_download_down() {
    
    
    int row=SelectedRow;
    if (row>=SizeListOfDownloads-1) return;
    tDownload *what=(tDownload *)gtk_clist_get_row_data(GTK_CLIST(ListOfDownloads),row);
    if (!what) return;
    freeze_clist();
    insert_to_clist_with_data(what,row+2);
    what->GTKCListRow=row+1;
    char *text;
    for (int i=1;i<=URL_COL;i++) {
        
        
        text=NULL;
        gtk_clist_get_text(GTK_CLIST(ListOfDownloads),row,i,&text);
        gtk_clist_set_text(GTK_CLIST(ListOfDownloads),row+2,i,text);
    };
    gtk_clist_remove(GTK_CLIST(ListOfDownloads),row);
    
    tDownload *what2=(tDownload *)gtk_clist_get_row_data(GTK_CLIST(ListOfDownloads),row);
    what2->GTKCListRow=row;
    SelectedRow+=1;
    gtk_clist_select_row(GTK_CLIST(ListOfDownloads),SelectedRow,0);
    if (WaitList->owner(what)) WaitList->backward(what);
    unfreeze_clist();
};
/* ******************************************************************** */
void init_status_bar() {
    
    
    ProgressBarValues = (GtkAdjustment *) gtk_adjustment_new (0, 1, 200 , 0, 0, 0);
    ProgressOfDownload = gtk_progress_bar_new_with_adjustment( ProgressBarValues);
    /* Set the format of the string that can be displayed in the
     * trough of the progress bar:
     * %p - percentage
     * %v - value
     * %l - lower range value
     * %u - upper range value */
    gtk_widget_set_usize(ProgressOfDownload,100,-1);
    gtk_progress_set_format_string (GTK_PROGRESS (ProgressOfDownload),
                                    "%p%%");
    gtk_progress_set_show_text(GTK_PROGRESS(ProgressOfDownload),TRUE);
    MainStatusBar=gtk_statusbar_new();
    ReadedBytesStatusBar=gtk_statusbar_new();
    StatusBarContext=gtk_statusbar_get_context_id(
                     GTK_STATUSBAR(MainStatusBar),"Main window context");
    RBStatusBarContext=gtk_statusbar_get_context_id(
                       GTK_STATUSBAR(ReadedBytesStatusBar),"Readed Bytes");
    gtk_statusbar_push(GTK_STATUSBAR(MainStatusBar),StatusBarContext,"Ready to go ????");
    gtk_statusbar_push(GTK_STATUSBAR(ReadedBytesStatusBar),RBStatusBarContext,"0");
    gtk_widget_set_usize(ReadedBytesStatusBar,150,-1);
};


void update_progress_bar() {
    
    
    tDownload *temp=(tDownload *)gtk_clist_get_row_data(
                    GTK_CLIST(ListOfDownloads),SelectedRow);
    int percent=0;
    if (temp) percent=temp->Percent.curent;
    if (percent>100) percent=100;
    gtk_progress_bar_update((GtkProgressBar *)ProgressOfDownload,(gfloat)percent/100);
    gtk_widget_show(ProgressOfDownload);
    gtk_statusbar_pop(GTK_STATUSBAR(ReadedBytesStatusBar),RBStatusBarContext);
    char data[MAX_LEN];
    sprintf(data,"%i(%iB/s)",READED_BYTES,GlobalMeter->last_value());
    gtk_statusbar_push(GTK_STATUSBAR(ReadedBytesStatusBar),RBStatusBarContext,data);
};
/* ******************************************************************** */
void init_main_window() {
    
     
    GtkWidget *hbox=gtk_hbox_new(FALSE,1);
    MainHBox=hbox;
    gtk_box_pack_start (GTK_BOX (hbox), MainStatusBar, TRUE, TRUE, 0);
    gtk_box_pack_start (GTK_BOX (hbox), ReadedBytesStatusBar, FALSE, FALSE, 0);
    gtk_box_pack_start (GTK_BOX (hbox), ProgressOfDownload, FALSE, FALSE, 0);

    MainLogList=gtk_clist_new(2);
    gtk_clist_set_column_width (GTK_CLIST(MainLogList),0,100);
    gtk_clist_set_column_width (GTK_CLIST(MainLogList),1,400);
    gtk_clist_set_column_justification (GTK_CLIST(MainLogList), 0, GTK_JUSTIFY_LEFT);
    gtk_clist_set_column_justification (GTK_CLIST(MainLogList), 1, GTK_JUSTIFY_LEFT);
    
	GtkWidget *hpaned=gtk_vpaned_new();
	GtkWidget *scroll_window=gtk_scrolled_window_new(NULL,NULL);
    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scroll_window),
                                    GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
    gtk_widget_set_usize(ListOfDownloads,-1,WINDOW_CLIST_HEIGHT);
    gtk_container_add(GTK_CONTAINER(scroll_window),MainLogList);
	gtk_paned_add1(GTK_PANED(hpaned),ContainerForCList);
	gtk_paned_add2(GTK_PANED(hpaned),scroll_window);

	GtkWidget *TEMP=gtk_statusbar_new();
    gtk_widget_set_usize(TEMP,106,-1);
    gtk_box_pack_end (GTK_BOX (hbox), TEMP, FALSE, FALSE, 0);
    
    GtkWidget *vbox=gtk_vbox_new(FALSE,1);
    gtk_box_pack_start (GTK_BOX (vbox), MainMenu, FALSE, FALSE, 0);
    gtk_box_pack_start (GTK_BOX (vbox), ButtonsBar, FALSE, FALSE, 0);
    gtk_box_pack_start (GTK_BOX (vbox), hpaned, TRUE, TRUE, 0);
    gtk_box_pack_end (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);
    gtk_container_add(GTK_CONTAINER(MainWindow),vbox);
    
    gtk_widget_show(MainStatusBar);
    gtk_widget_show(ProgressOfDownload);
    gtk_widget_show(TEMP);
    gtk_widget_show(ReadedBytesStatusBar);
    gtk_progress_bar_update((GtkProgressBar *)ProgressOfDownload,0);
    gtk_widget_show(ListOfDownloads);
    gtk_widget_show(ButtonsBar);
    
    gtk_widget_show(ContainerForCList);
    gtk_widget_show(MainLogList);
	gtk_widget_show(scroll_window);
	gtk_widget_show(hpaned);
    gtk_widget_show(MainMenu);
    gtk_widget_show(hbox);
    gtk_widget_show(vbox);
    gtk_widget_show(MainWindow);
    int temp,w,h;
    gdk_window_get_geometry(NULL,&temp,&temp,&w,&h,&temp);
    if (WINDOW_X_POSITION>w) WINDOW_X_POSITION=20;
    if (WINDOW_Y_POSITION>h) WINDOW_Y_POSITION=20;
    gdk_window_move_resize(MainWindow->window,WINDOW_X_POSITION,WINDOW_Y_POSITION,WINDOW_WIDTH,WINDOW_HEIGHT);
    init_graph();
//    gtk_widget_set_usize(ListOfDownloads,-1,-1);
    gtk_signal_connect(GTK_OBJECT(TEMP), "expose_event",
                       GTK_SIGNAL_FUNC(draw_graph),
                       NULL);
};

/* ******************************************************************* */
int time_for_refresh(void *a) {
    aa.main_circle();
    update_progress_bar();
    recalc_graph();
    MainTimer = gtk_timeout_add (2000, time_for_refresh , NULL);
    return 0;
};

int time_for_logs_refresh(void *a) {
    
    
    aa.redraw_logs();
    LogsTimer = gtk_timeout_add (100, time_for_logs_refresh , NULL);
    return 0;
};

void get_size_of_clist(){
   	gint x;
   	gdk_window_get_size(ListOfDownloads->window,&x,&WINDOW_CLIST_HEIGHT);
};

int get_mainwin_sizes(GtkWidget *window) {
    if (FirstConfigureEvent){
		FirstConfigureEvent=0;
		return FALSE;
    };
    if (window!=NULL && window->window!=NULL){
    	gdk_window_get_position(window->window,&WINDOW_X_POSITION,&WINDOW_Y_POSITION);
    	gdk_window_get_size(window->window,&WINDOW_WIDTH,&WINDOW_HEIGHT);
    };
    return FALSE;
};

int time_for_draw_graph(void *a) {
    draw_graph();
    GraphTimer = gtk_timeout_add (1000, time_for_draw_graph , NULL);
    return 0;
};

void init_timeouts() {
    MainTimer = gtk_timeout_add (2000, time_for_refresh , NULL);
    GraphTimer = gtk_timeout_add (100, time_for_draw_graph , NULL);
    LogsTimer = gtk_timeout_add (100, time_for_logs_refresh , NULL);
    FirstConfigureEvent=1;
    gtk_signal_connect(GTK_OBJECT(MainWindow), "configure_event",
                       GTK_SIGNAL_FUNC(get_mainwin_sizes),
                       MainWindow);
};

void init_face(int argc, char *argv[]) {
    gtk_init(&argc, &argv);
    gdk_rgb_init();
    MainWindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title(GTK_WINDOW (MainWindow), VERSION_NAME);
    gtk_widget_realize(MainWindow);
    gtk_widget_set_usize( GTK_WIDGET (MainWindow), 400, 200);
    MainWindowGC=gdk_gc_new(MainWindow->window);
    init_main_menu();
    init_list_menu();
    init_status_bar();
    init_view_list();
    init_buttons_bar();
    init_main_window();
#include "pixmaps/logo.xpm"
	GdkBitmap *bitmap;
    GdkPixmap *pixmap=make_pixmap_from_xpm(&bitmap,logo_xpm);
    gdk_window_set_icon(MainWindow->window,NULL,pixmap,bitmap);
    gtk_signal_connect(GTK_OBJECT(MainWindow), "delete_event",
                       GTK_SIGNAL_FUNC(my_main_quit),
                       NULL);
};
