/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
#include "list.h"
#include "lmenu.h"
#include "../dlist.h"

GtkWidget *ListMenu;
GtkWidget *ListMenuArray[10];
extern gint SelectedRow;
extern gint SizeListOfDownloads;

GtkWidget *make_menu_item(char *name,char *accel,GdkPixmap *pixmap,GdkBitmap *bitmap) {
    GtkWidget *menu_item=gtk_menu_item_new();
    GtkWidget *hbox=gtk_hbox_new(FALSE,3);
    GtkWidget *label=gtk_label_new(name);
    GtkWidget *pix=gtk_pixmap_new(pixmap,bitmap);
    gtk_box_pack_start(GTK_BOX(hbox),pix,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
    if (accel) {
        GtkWidget *lab=gtk_label_new(accel);
        GtkWidget *hbox2=gtk_hbox_new(FALSE,0);
        gtk_box_pack_end(GTK_BOX(hbox2),lab,FALSE,FALSE,0);
        gtk_box_pack_end(GTK_BOX(hbox),hbox2,FALSE,FALSE,0);
        gtk_widget_set_usize(hbox2,70,-1);
    };
    gtk_container_add(GTK_CONTAINER(menu_item),hbox);
    return menu_item;
};

void init_list_menu() {
#include "pixmaps/empty.xpm"
#include "pixmaps/stopmini.xpm"
#include "pixmaps/logmini.xpm"
#include "pixmaps/delmini.xpm"
#include "pixmaps/runmini.xpm"
#include "pixmaps/delcommini.xpm"
#include "pixmaps/upmini.xpm"
#include "pixmaps/downmini.xpm"
    GdkPixmap *pixmap,*emptypix;
    GdkBitmap *bitmap,*emptymask;
    GtkWidget *menu_item;

    ListMenu=gtk_menu_new();
    emptypix=make_pixmap_from_xpm(&emptymask,empty_xpm);

    pixmap=make_pixmap_from_xpm(&bitmap,logmini_xpm);
    menu_item=make_menu_item("View log",NULL,pixmap,bitmap);
    gtk_menu_append(GTK_MENU(ListMenu),menu_item);
    ListMenuArray[LM_LOG]=menu_item;
    gtk_signal_connect(GTK_OBJECT(menu_item),"activate",GTK_SIGNAL_FUNC(open_log_for_selected),NULL);

    pixmap=make_pixmap_from_xpm(&bitmap,stopmini_xpm);
    menu_item=make_menu_item("Stop","Alt+S",pixmap,bitmap);
    gtk_widget_set_usize(menu_item,130,-1);
    gtk_menu_append(GTK_MENU(ListMenu),menu_item);
    ListMenuArray[LM_STOP]=menu_item;
    gtk_signal_connect(GTK_OBJECT(menu_item),"activate",GTK_SIGNAL_FUNC(stop_download),NULL);
    
    pixmap=make_pixmap_from_xpm(&bitmap,runmini_xpm);
    menu_item=make_menu_item("Continue download",NULL,pixmap,bitmap);
    gtk_menu_append(GTK_MENU(ListMenu),menu_item);
    ListMenuArray[LM_CONTINUE]=menu_item;
    gtk_signal_connect(GTK_OBJECT(menu_item),"activate",GTK_SIGNAL_FUNC(continue_download),NULL);

    menu_item=gtk_menu_item_new();
    gtk_widget_set_sensitive(menu_item,FALSE);
    gtk_menu_append(GTK_MENU(ListMenu),menu_item);

    menu_item=make_menu_item("Properties","Alt+E",emptypix,emptymask);
    gtk_menu_append(GTK_MENU(ListMenu),menu_item);
    ListMenuArray[LM_EDIT]=menu_item;
    gtk_signal_connect(GTK_OBJECT(menu_item),"activate",GTK_SIGNAL_FUNC(open_edit_for_selected),NULL);

    pixmap=make_pixmap_from_xpm(&bitmap,delmini_xpm);
    menu_item=make_menu_item("Delete download","Alt+C",pixmap,bitmap);
    gtk_menu_append(GTK_MENU(ListMenu),menu_item);
    ListMenuArray[LM_DEL]=menu_item;
    gtk_signal_connect(GTK_OBJECT(menu_item),"activate",GTK_SIGNAL_FUNC(delete_download),NULL);

    pixmap=make_pixmap_from_xpm(&bitmap,delcommini_xpm);
    menu_item=make_menu_item("Delete completed",NULL,pixmap,bitmap);
    gtk_menu_append(GTK_MENU(ListMenu),menu_item);
    ListMenuArray[LM_DELC]=menu_item;
    gtk_signal_connect(GTK_OBJECT(menu_item),"activate",GTK_SIGNAL_FUNC(del_completed_downloads),NULL);


    menu_item=make_menu_item("Delete fataled",NULL,emptypix,emptymask);
    gtk_menu_append(GTK_MENU(ListMenu),menu_item);
    ListMenuArray[LM_DELF]=menu_item;
    gtk_signal_connect(GTK_OBJECT(menu_item),"activate",GTK_SIGNAL_FUNC(del_fataled_downloads),NULL);

    menu_item=gtk_menu_item_new();
    gtk_widget_set_sensitive(menu_item,FALSE);
    gtk_menu_append(GTK_MENU(ListMenu),menu_item);

    pixmap=make_pixmap_from_xpm(&bitmap,upmini_xpm);
    menu_item=make_menu_item("Move up","Shift+Up",pixmap,bitmap);
    gtk_menu_append(GTK_MENU(ListMenu),menu_item);
    ListMenuArray[LM_MOVEUP]=menu_item;
    gtk_signal_connect(GTK_OBJECT(menu_item),"activate",GTK_SIGNAL_FUNC(move_download_up),NULL);

    pixmap=make_pixmap_from_xpm(&bitmap,downmini_xpm);
    menu_item=make_menu_item("Move down","Shift+Down",pixmap,bitmap);
    gtk_widget_set_usize(menu_item,200,-1);
    gtk_menu_append(GTK_MENU(ListMenu),menu_item);
    ListMenuArray[LM_MOVEDOWN]=menu_item;
    gtk_signal_connect(GTK_OBJECT(menu_item),"activate",GTK_SIGNAL_FUNC(move_download_down),NULL);

    gtk_widget_show_all(ListMenu);
};

void list_menu_prepare(){
	if (SelectedRow<0){
        for (int i=0;i<=LM_MOVEDOWN;i++)
		    gtk_widget_set_sensitive(ListMenuArray[i],FALSE);
	}else{
	    tDownload *temp=(tDownload *)gtk_clist_get_row_data(
        					GTK_CLIST(ListOfDownloads),SelectedRow);
        for (int i=0;i<=LM_MOVEDOWN;i++)
		    gtk_widget_set_sensitive(ListMenuArray[i],TRUE);
		if (!temp->LOG)
			gtk_widget_set_sensitive(ListMenuArray[LM_LOG],FALSE);
		if (!temp->GTKCListRow)
			gtk_widget_set_sensitive(ListMenuArray[LM_MOVEUP],FALSE);
		if (temp->GTKCListRow==SizeListOfDownloads-1)
			gtk_widget_set_sensitive(ListMenuArray[LM_MOVEDOWN],FALSE);
        switch (temp->owner){
        	case DL_WAIT:
			    gtk_widget_set_sensitive(ListMenuArray[LM_CONTINUE],FALSE);
        	case DL_STOP:
        	case DL_PAUSE:
        	case DL_COMPLETE:{
			    gtk_widget_set_sensitive(ListMenuArray[LM_STOP],FALSE);
        		break;
        	};
        	case DL_RUN:{
			    gtk_widget_set_sensitive(ListMenuArray[LM_CONTINUE],FALSE);
			    gtk_widget_set_sensitive(ListMenuArray[LM_EDIT],FALSE);
			};
        };
	};
};