/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <gtk/gtk.h>
#include <stdio.h>
#include <pthread.h>
#include <string.h>


#include "../dlist.h"
#include "../var.h"
#include "list.h"
#include "colors.h"
struct tLogWindow{
    GtkWidget *window;
    GtkWidget *clist;
    GtkWidget *swindow;
    pthread_mutex_t mutex;
};

void destroy_log_window_by_log(void *a) {

    tLog *log=(tLog *) a;
    if (log) {
        tLogWindow *temp=(tLogWindow *)log->Window;
        if (temp) {
            pthread_mutex_lock(&temp->mutex);
            log->Window=NULL;
            gtk_widget_destroy(GTK_WIDGET(temp->window));
            pthread_mutex_unlock(&temp->mutex);
            delete (temp);
        };
    };

};

void destroy_log_window(void *a) {

    tLog *log=(tLog *) gtk_object_get_user_data(GTK_OBJECT(a));
    if (log) {
        tLogWindow *temp=(tLogWindow *)log->Window;
        if (temp) {
            pthread_mutex_lock(&temp->mutex);
            log->Window=NULL;
            gtk_widget_destroy(GTK_WIDGET(a));
            pthread_mutex_unlock(&temp->mutex);
            delete (temp);
        };
    };

};

void log_window_add_string(tLog *log,tLogString *str) {
    tLogWindow *temp=(tLogWindow *)log->Window;
    if (!temp) return;
    pthread_mutex_lock(&temp->mutex);
    char a[MAX_LEN],useless[MAX_LEN],useful[MAX_LEN];
    sprintf(a,"%s ",ctime(&str->time));
    sscanf(a,"%s %s %s %s",useless,useless,useless,useful);
    char *data[]={useful,str->body};
    int row=gtk_clist_append(GTK_CLIST(temp->clist),data);
    GdkColor color;
    switch (str->type) {
        case LOG_OK: {
                color=BLACK;
                break;
            };
        case LOG_SERVER: {
                color=BLUE;
                break;
            };
        case LOG_WARNING: {
                color=GREEN;
                break;
            };
        case LOG_ERROR: {
                color=RED;
                break;
            };
        default: color=BLACK;
    };
    GdkColormap *colormap = gtk_widget_get_colormap (MainWindow);
    gdk_color_alloc (colormap, &color);
    gtk_clist_set_foreground(GTK_CLIST(temp->clist),row,&color);
    pthread_mutex_unlock(&temp->mutex);
};

void init_log_window(tDownload *what) {

    gchar *titles[]={"",""};
    if (what && what->LOG && !what->LOG->Window) {
        tLogWindow *temp=new tLogWindow;
        pthread_mutex_init(&temp->mutex,NULL);
        temp->window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
        gtk_widget_set_usize( GTK_WIDGET (temp->window), 400, 150);
        char title[MAX_LEN];
        title[0]=0;
        strcat(title,"Log: ");
        strcat(title,what->info->file);
        gtk_window_set_title(GTK_WINDOW (temp->window), title);
        gtk_signal_connect(GTK_OBJECT(temp->window), "delete_event",
                           (GtkSignalFunc)destroy_log_window, what->LOG);

        temp->clist = gtk_clist_new_with_titles( 2, titles);
        gtk_clist_column_titles_hide(GTK_CLIST(temp->clist));
        gtk_clist_set_shadow_type (GTK_CLIST(temp->clist), GTK_SHADOW_IN);
        gtk_clist_set_column_width (GTK_CLIST(temp->clist), 0 , 50);
        gtk_clist_set_column_width (GTK_CLIST(temp->clist), 1 , 400);

        temp->swindow=gtk_scrolled_window_new(NULL,NULL);
        gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (temp->swindow),
                                        GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
        gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW (temp->swindow),
                                              temp->clist);
        gtk_container_add(GTK_CONTAINER(temp->window),temp->swindow);

        what->LOG->Window=temp;
        what->LOG->print();
        gtk_object_set_user_data(GTK_OBJECT(temp->window),what->LOG);
        gtk_widget_show(temp->clist);
        gtk_widget_show(temp->swindow);
        gtk_widget_show(temp->window);
    };
};

void del_first_from_log(tLog *what) {

    tLogWindow *temp=(tLogWindow *)what->Window;
    if (temp) {
        pthread_mutex_lock(&temp->mutex);
        gtk_clist_remove(GTK_CLIST(temp->clist),0);
        pthread_mutex_unlock(&temp->mutex);
    };

};
