/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <gtk/gtk.h>
#include <stdio.h>
#include "prefs.h"
#include "edit.h"
#include "../var.h"
#include "../main.h"
#include "../config.h"
#include "../locstr.h"

extern tMain aa;

GtkWidget *options_window=NULL;
GtkWidget *options_window_notebook;
GtkWidget *options_window_vbox;

GtkWidget *prefs_common_vbox;
GtkWidget *prefs_common_table;
GtkWidget *prefs_common_frame;
GtkWidget *prefs_common_del_completed;
GtkWidget *prefs_common_del_fataled;
GtkWidget *prefs_common_recursive;
GtkWidget *prefs_common_retry_if_noreget;

GtkWidget *prefs_limits_frame;
GtkWidget *prefs_limits_vbox;
GtkWidget *prefs_limits_table;
GtkWidget *prefs_limits_max_threads,*prefs_limits_tbox,*prefs_limits_tlabel;
GtkWidget *prefs_limits_timeout,*prefs_limits_tibox,*prefs_limits_tilabel;
GtkWidget *prefs_limits_log,*prefs_limits_lbox,*prefs_limits_llabel;
GtkWidget *prefs_limits_retry_timeout,*prefs_limits_rtbox,*prefs_limits_rtlabel;
GtkWidget *prefs_limits_max_retries,*prefs_limits_rbox,*prefs_limits_rlabel;

GtkWidget *prefs_other_frame;
GtkWidget *prefs_other_vbox;
GtkWidget *prefs_other_table;
GtkWidget *prefs_other_savepath,*prefs_other_sbox,*prefs_other_slabel;

GtkWidget *prefs_columns_nums_button1,*prefs_columns_nums_button2,*prefs_columns_nums_button3;
GtkWidget *prefs_columns_time_button1,*prefs_columns_time_button2;

GtkWidget *dir_browser=NULL;
GtkWidget *ok_button,*cancel_button;
GtkWidget *buttons_hbox;

void options_browser_ok(...) {
    char *tmp;
    tmp=gtk_file_selection_get_filename(GTK_FILE_SELECTION(dir_browser));
    gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(prefs_other_savepath)->entry),tmp);
    gtk_widget_destroy(dir_browser);
    dir_browser=NULL;
};

void options_browser_cancel(...) {
    gtk_widget_destroy(dir_browser);
    dir_browser=NULL;
};

void options_browser_open() {
    if (dir_browser) return;
    dir_browser=gtk_file_selection_new("Select directory");
    gtk_widget_set_sensitive(GTK_FILE_SELECTION(dir_browser)->file_list,FALSE);
    char *tmp=gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(prefs_other_savepath)->entry));
    if (tmp && *tmp)
        gtk_file_selection_set_filename(GTK_FILE_SELECTION(dir_browser),tmp);
    gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(dir_browser)->ok_button),
                       "clicked",GTK_SIGNAL_FUNC(options_browser_ok),prefs_other_savepath);
    gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(dir_browser)->cancel_button),
                       "clicked",GTK_SIGNAL_FUNC(options_browser_cancel),dir_browser);
    gtk_signal_connect(GTK_OBJECT(&(GTK_FILE_SELECTION(dir_browser)->window)),
                       "delete_event",GTK_SIGNAL_FUNC(options_browser_cancel),dir_browser);
    gtk_widget_show(dir_browser);
};

void init_options_window(...) {
    if (options_window) return;
    options_window=gtk_window_new(GTK_WINDOW_DIALOG);
    gtk_window_set_title(GTK_WINDOW(options_window),"Options");
    gtk_window_set_position(GTK_WINDOW(options_window),GTK_WIN_POS_CENTER);
    gtk_window_set_policy (GTK_WINDOW(options_window), FALSE,FALSE,FALSE);
    gtk_widget_set_usize(options_window,460,223);
    gtk_signal_connect(GTK_OBJECT(options_window),"delete_event",GTK_SIGNAL_FUNC(options_window_cancel), NULL);
    options_window_vbox=gtk_vbox_new(FALSE,10);
    gtk_box_set_spacing(GTK_BOX(options_window_vbox),5);
    gtk_container_border_width(GTK_CONTAINER(options_window),5);
    gtk_container_add(GTK_CONTAINER(options_window),options_window_vbox);
    options_window_notebook=gtk_notebook_new();
    gtk_box_pack_start(GTK_BOX(options_window_vbox),options_window_notebook,TRUE,TRUE,0);

    /*
        Common options
     */

    prefs_common_vbox=gtk_vbox_new(FALSE,0);
    prefs_common_frame=gtk_frame_new("Options");
    gtk_box_pack_start(GTK_BOX(prefs_common_vbox),prefs_common_frame,FALSE,FALSE,0);
    gtk_container_border_width(GTK_CONTAINER(prefs_common_frame),5);
    prefs_common_table=gtk_table_new(1,4,FALSE);
    gtk_container_add(GTK_CONTAINER(prefs_common_frame),prefs_common_table);
    gtk_container_border_width(GTK_CONTAINER(prefs_common_table),5);
    prefs_common_del_completed=gtk_check_button_new_with_label("Automatic delete completed downloads");
    gtk_table_attach_defaults(GTK_TABLE(prefs_common_table),prefs_common_del_completed,1,2,0,1);
    prefs_common_del_fataled=gtk_check_button_new_with_label("Automatic delete fataled downloads");
    gtk_table_attach_defaults(GTK_TABLE(prefs_common_table),prefs_common_del_fataled,1,2,1,2);
    prefs_common_recursive=gtk_check_button_new_with_label("Optimized recursive downloads");
    gtk_table_attach_defaults(GTK_TABLE(prefs_common_table),prefs_common_recursive,1,2,3,4);
    prefs_common_retry_if_noreget=gtk_check_button_new_with_label("Retry if reget is not supported");
    gtk_table_attach_defaults(GTK_TABLE(prefs_common_table),prefs_common_retry_if_noreget,1,2,4,5);
    gtk_notebook_append_page(GTK_NOTEBOOK(options_window_notebook),prefs_common_vbox,gtk_label_new("Common"));

    /*
        Limits options
     */
    prefs_limits_vbox=gtk_vbox_new(FALSE,0);
    prefs_limits_frame=gtk_frame_new("Limits");
    gtk_box_pack_start(GTK_BOX(prefs_limits_vbox),prefs_limits_frame,FALSE,FALSE,0);
    gtk_container_border_width(GTK_CONTAINER(prefs_limits_frame),5);
    prefs_limits_table=gtk_table_new(1,4,FALSE);
    gtk_container_add(GTK_CONTAINER(prefs_limits_frame),prefs_limits_table);
    gtk_container_border_width(GTK_CONTAINER(prefs_limits_table),5);

    char temp[MAX_LEN];
    prefs_limits_tbox=gtk_hbox_new(FALSE,0);
    prefs_limits_max_threads=gtk_entry_new_with_max_length(2);
    gtk_widget_set_usize(prefs_limits_max_threads,30,-1);
    sprintf(temp,"%i",MAX_THREADS);
    gtk_entry_set_text(GTK_ENTRY(prefs_limits_max_threads),temp);
    gtk_box_pack_start(GTK_BOX(prefs_limits_tbox),prefs_limits_max_threads,FALSE,FALSE,0);
    prefs_limits_tlabel=gtk_label_new("Maximum active downloads");
    gtk_box_pack_start(GTK_BOX(prefs_limits_tbox),prefs_limits_tlabel,FALSE,FALSE,0);
    gtk_table_attach_defaults(GTK_TABLE(prefs_limits_table),prefs_limits_tbox,1,2,0,1);

    prefs_limits_rtbox=gtk_hbox_new(FALSE,0);
    prefs_limits_retry_timeout=gtk_entry_new_with_max_length(2);
    gtk_widget_set_usize(prefs_limits_retry_timeout,30,-1);
    sprintf(temp,"%i",RETRY_TIME_OUT);
    gtk_entry_set_text(GTK_ENTRY(prefs_limits_retry_timeout),temp);
    gtk_box_pack_start(GTK_BOX(prefs_limits_rtbox),prefs_limits_retry_timeout,FALSE,FALSE,0);
    prefs_limits_rtlabel=gtk_label_new("Timeout after break (secs)");
    gtk_box_pack_start(GTK_BOX(prefs_limits_rtbox),prefs_limits_rtlabel,FALSE,FALSE,0);
    gtk_table_attach_defaults(GTK_TABLE(prefs_limits_table),prefs_limits_rtbox,1,2,1,2);

    prefs_limits_tibox=gtk_hbox_new(FALSE,0);
    prefs_limits_timeout=gtk_entry_new_with_max_length(3);
    gtk_widget_set_usize(prefs_limits_timeout,30,-1);
    sprintf(temp,"%i",TIME_OUT);
    gtk_entry_set_text(GTK_ENTRY(prefs_limits_timeout),temp);
    gtk_box_pack_start(GTK_BOX(prefs_limits_tibox),prefs_limits_timeout,FALSE,FALSE,0);
    prefs_limits_tilabel=gtk_label_new("Timeout for reading from socket (secs)");
    gtk_box_pack_start(GTK_BOX(prefs_limits_tibox),prefs_limits_tilabel,FALSE,FALSE,0);
    gtk_table_attach_defaults(GTK_TABLE(prefs_limits_table),prefs_limits_tibox,1,2,2,3);

    prefs_limits_lbox=gtk_hbox_new(FALSE,0);
    prefs_limits_log=gtk_entry_new_with_max_length(3);
    gtk_widget_set_usize(prefs_limits_log,30,-1);
    sprintf(temp,"%i",MAX_LOG_LENGTH);
    gtk_entry_set_text(GTK_ENTRY(prefs_limits_log),temp);
    gtk_box_pack_start(GTK_BOX(prefs_limits_lbox),prefs_limits_log,FALSE,FALSE,0);
    prefs_limits_llabel=gtk_label_new("Maximum lines in log");
    gtk_box_pack_start(GTK_BOX(prefs_limits_lbox),prefs_limits_llabel,FALSE,FALSE,0);
    gtk_table_attach_defaults(GTK_TABLE(prefs_limits_table),prefs_limits_lbox,1,2,3,4);

    prefs_limits_rbox=gtk_hbox_new(FALSE,0);
    prefs_limits_max_retries=gtk_entry_new_with_max_length(3);
    gtk_widget_set_usize(prefs_limits_max_retries,30,-1);
    sprintf(temp,"%i",MAX_RETRIES);
    gtk_entry_set_text(GTK_ENTRY(prefs_limits_max_retries),temp);
    gtk_box_pack_start(GTK_BOX(prefs_limits_rbox),prefs_limits_max_retries,FALSE,FALSE,0);
    prefs_limits_rlabel=gtk_label_new("Retries amount");
    gtk_box_pack_start(GTK_BOX(prefs_limits_rbox),prefs_limits_rlabel,FALSE,FALSE,0);
    gtk_table_attach_defaults(GTK_TABLE(prefs_limits_table),prefs_limits_rbox,1,2,4,5);

    gtk_notebook_append_page(GTK_NOTEBOOK(options_window_notebook),prefs_limits_vbox,gtk_label_new("Limits"));
    /*
     *	Other options
     */
    prefs_other_vbox=gtk_vbox_new(FALSE,0);
    prefs_other_frame=gtk_frame_new("Other");
    gtk_box_pack_start(GTK_BOX(prefs_other_vbox),prefs_other_frame,FALSE,FALSE,0);
    gtk_container_border_width(GTK_CONTAINER(prefs_other_frame),5);
    prefs_other_table=gtk_table_new(1,4,FALSE);
    gtk_container_add(GTK_CONTAINER(prefs_other_frame),prefs_other_table);
    gtk_container_border_width(GTK_CONTAINER(prefs_other_table),5);

    prefs_other_sbox=gtk_vbox_new(FALSE,0);
    prefs_other_savepath=gtk_combo_new();
    GList *PathList=make_glist_from_mylist(PathHistory);
    if (PathList)
        gtk_combo_set_popdown_strings (GTK_COMBO (prefs_other_savepath), PathList);

    gtk_widget_set_usize(GTK_COMBO(prefs_other_savepath)->entry,350,-1);
    GtkWidget *dir_browser_button=gtk_button_new_with_label("Browse");
    GtkWidget *hboxtemp=gtk_hbox_new(FALSE,0);
    gtk_box_set_spacing(GTK_BOX(hboxtemp),5);
    gtk_box_pack_start(GTK_BOX(hboxtemp),prefs_other_savepath,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(hboxtemp),dir_browser_button,FALSE,FALSE,0);
    gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(prefs_other_savepath)->entry),GLOBAL_SAVE_PATH);
    gtk_signal_connect(GTK_OBJECT(dir_browser_button),"clicked",GTK_SIGNAL_FUNC(options_browser_open),NULL);
    prefs_other_slabel=gtk_label_new("Save downloads to folder");
    gtk_box_pack_start(GTK_BOX(prefs_other_sbox),prefs_other_slabel,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(prefs_other_sbox),hboxtemp,FALSE,FALSE,0);
    gtk_table_attach_defaults(GTK_TABLE(prefs_other_table),prefs_other_sbox,1,2,0,1);

    gtk_notebook_append_page(GTK_NOTEBOOK(options_window_notebook),prefs_other_vbox,gtk_label_new("Other"));
    /*
     * Columns options
     */
	GtkWidget *columns_hbox=gtk_hbox_new(FALSE,0);
    gtk_box_set_spacing(GTK_BOX(columns_hbox),5);
	GtkWidget *columns_frame1=gtk_frame_new("Size format");
	GtkWidget *columns_frame2=gtk_frame_new("Time format");
    gtk_container_border_width(GTK_CONTAINER(columns_frame1),5);
    gtk_container_border_width(GTK_CONTAINER(columns_frame2),5);
 	GtkWidget *columns_vbox1=gtk_vbox_new(FALSE,0);
	GtkWidget *columns_vbox2=gtk_vbox_new(FALSE,0);
	
	prefs_columns_nums_button1=gtk_radio_button_new_with_label(NULL,"123456");
	gtk_box_pack_start(GTK_BOX(columns_vbox1),prefs_columns_nums_button1,FALSE,FALSE,0);
	GSList *columns_group1=gtk_radio_button_group(GTK_RADIO_BUTTON(prefs_columns_nums_button1));
	prefs_columns_nums_button2=gtk_radio_button_new_with_label(columns_group1,"123 456");
	gtk_box_pack_start(GTK_BOX(columns_vbox1),prefs_columns_nums_button2,FALSE,FALSE,0);
	prefs_columns_nums_button3=gtk_radio_button_new_with_label(
		gtk_radio_button_group(GTK_RADIO_BUTTON(prefs_columns_nums_button2)),"123K");
	gtk_box_pack_start(GTK_BOX(columns_vbox1),prefs_columns_nums_button3,FALSE,FALSE,0);

	switch(NICE_DEC_DIGITALS){
		case 1:{
			gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(prefs_columns_nums_button2),TRUE);
			break;
		};
		case 2:{
			gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(prefs_columns_nums_button3),TRUE);
			break;
		};
		default:
			gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(prefs_columns_nums_button1),TRUE);
	};
	prefs_columns_time_button1=gtk_radio_button_new_with_label(NULL,"12:34:56");
	gtk_box_pack_start(GTK_BOX(columns_vbox2),prefs_columns_time_button1,FALSE,FALSE,0);
	GSList *columns_group2=gtk_radio_button_group(GTK_RADIO_BUTTON(prefs_columns_time_button1));
	prefs_columns_time_button2=gtk_radio_button_new_with_label(columns_group2,"12:34");
	gtk_box_pack_start(GTK_BOX(columns_vbox2),prefs_columns_time_button2,FALSE,FALSE,0);
	if (TIME_FORMAT)
			gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(prefs_columns_time_button2),TRUE);
	else
			gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(prefs_columns_time_button1),TRUE);
	gtk_container_add(GTK_CONTAINER(columns_frame1),columns_vbox1);
	GtkWidget *columns_vbox11=gtk_vbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(columns_vbox11),columns_frame1,FALSE,FALSE,0);
	GtkWidget *columns_vbox12=gtk_vbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(columns_vbox11),columns_vbox12,FALSE,FALSE,0);
	
	gtk_container_add(GTK_CONTAINER(columns_frame2),columns_vbox2);
	GtkWidget *columns_vbox21=gtk_vbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(columns_vbox21),columns_frame2,FALSE,FALSE,0);
	GtkWidget *columns_vbox22=gtk_vbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(columns_vbox21),columns_vbox22,FALSE,FALSE,0);
	
	gtk_box_pack_start(GTK_BOX(columns_hbox),columns_vbox11,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(columns_hbox),columns_vbox21,FALSE,FALSE,0);
	
	GtkWidget *columns_frame=gtk_frame_new("Columns");
    gtk_container_border_width(GTK_CONTAINER(columns_frame),5);
	gtk_container_add(GTK_CONTAINER(columns_frame),columns_hbox);
    gtk_notebook_append_page(GTK_NOTEBOOK(options_window_notebook),columns_frame,gtk_label_new("Columns"));
    /*
        Buttons Ok and Cancel
     */
    buttons_hbox=gtk_hbutton_box_new();
    gtk_button_box_set_layout(GTK_BUTTON_BOX(buttons_hbox),GTK_BUTTONBOX_END);
    gtk_button_box_set_spacing(GTK_BUTTON_BOX(buttons_hbox),5);
    gtk_box_pack_start(GTK_BOX(options_window_vbox),buttons_hbox,FALSE,FALSE,0);
    ok_button=gtk_button_new_with_label("Ok");
    cancel_button=gtk_button_new_with_label("Cancel");
    gtk_signal_connect(GTK_OBJECT(cancel_button),"clicked",GTK_SIGNAL_FUNC(options_window_cancel),NULL);
    gtk_signal_connect(GTK_OBJECT(ok_button),"clicked",GTK_SIGNAL_FUNC(options_window_ok),NULL);
    GTK_WIDGET_SET_FLAGS(ok_button,GTK_CAN_DEFAULT);
    GTK_WIDGET_SET_FLAGS(cancel_button,GTK_CAN_DEFAULT);
    gtk_box_pack_start(GTK_BOX(buttons_hbox),ok_button,TRUE,TRUE,0);
    gtk_box_pack_start(GTK_BOX(buttons_hbox),cancel_button,TRUE,TRUE,0);

    toggle_button_set_state(GTK_TOGGLE_BUTTON(prefs_common_del_fataled),DELETE_FATAL);
    toggle_button_set_state(GTK_TOGGLE_BUTTON(prefs_common_del_completed),DELETE_COMPLETED);
    toggle_button_set_state(GTK_TOGGLE_BUTTON(prefs_common_recursive),RECURSIVE_OPTIMIZE);
    toggle_button_set_state(GTK_TOGGLE_BUTTON(prefs_common_retry_if_noreget),RETRY_IF_NOREGET);
    gtk_window_set_default(GTK_WINDOW(options_window),ok_button);
    gtk_widget_show_all(options_window);
};

void options_window_cancel() {
    gtk_widget_destroy(options_window);
    options_window=NULL;
    if (dir_browser) options_browser_cancel();
};

void options_window_ok() {
    DELETE_FATAL=GTK_TOGGLE_BUTTON(prefs_common_del_fataled)->active;
    DELETE_COMPLETED=GTK_TOGGLE_BUTTON(prefs_common_del_completed)->active;
    RECURSIVE_OPTIMIZE=GTK_TOGGLE_BUTTON(prefs_common_recursive)->active;
    RETRY_IF_NOREGET=GTK_TOGGLE_BUTTON(prefs_common_retry_if_noreget)->active;
    TIME_FORMAT=GTK_TOGGLE_BUTTON(prefs_columns_time_button2)->active;
    if (GTK_TOGGLE_BUTTON(prefs_columns_nums_button2)->active)
    	NICE_DEC_DIGITALS=1;
    else{
	    if (GTK_TOGGLE_BUTTON(prefs_columns_nums_button3)->active)
	    	NICE_DEC_DIGITALS=2;
	    else
	    	NICE_DEC_DIGITALS=0;
    };
    if (DELETE_COMPLETED) aa.del_completed();
    int  temp=0;
    sscanf(gtk_entry_get_text(GTK_ENTRY(prefs_limits_timeout)),"%u",&temp);
    if (temp>30) TIME_OUT=temp;
    sscanf(gtk_entry_get_text(GTK_ENTRY(prefs_limits_max_threads)),"%u",&temp);
    if (temp>0 && temp<51) MAX_THREADS=temp;
    sscanf(gtk_entry_get_text(GTK_ENTRY(prefs_limits_retry_timeout)),"%u",&temp);
    if (temp>0) RETRY_TIME_OUT=temp;
    sscanf(gtk_entry_get_text(GTK_ENTRY(prefs_limits_max_retries)),"%u",&temp);
    MAX_RETRIES=temp;
    sscanf(gtk_entry_get_text(GTK_ENTRY(prefs_limits_log)),"%u",&temp);
    if (temp>100) MAX_LOG_LENGTH=temp;
    delete (GLOBAL_SAVE_PATH);
    PathHistory->add(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(prefs_other_savepath)->entry)));
    GLOBAL_SAVE_PATH=copy_string(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(prefs_other_savepath)->entry)));
    /*  There we need to make new loglimit for all logs
     */
    options_window_cancel();
    save_config();
};

void toggle_button_set_state(GtkToggleButton *tb,gboolean state) {
#if (GTK_MAJOR_VERSION==1) && (GTK_MINOR_VERSION==1) && (GTK_MICRO_VERSION<=12)
    gtk_toggle_button_set_state(tb,state);
#else
    gtk_toggle_button_set_active(tb,state);
#endif
}
