/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <string.h>
#include <stdio.h>

#include "var.h"

char *copy_string(char *src,int len) {
    char *temp=new char[len+1];
    strncpy(temp,src,len);
    temp[len]=0;
    return temp;
};

char *copy_string(char *src) {
    if (!src) return NULL;
    int len=strlen(src);
    return copy_string(src,len);
};

int equal(char *a,char *b) {
    if (!a) {
        if (b) return 0;
        return 1;
    };
    if (!b) return 0;
    while (*a==*b && *a!=0) {
        a++;
        b++;
    };
    if (*b==*a) return 1;
    return 0;
};

int equal_first(char *a,char *b) {
    if (a==NULL || b==NULL) return 1;
    int la=strlen(a);
    int lb=strlen(b);
    int min=la<lb?la:lb;
    return !strncmp(a,b,min);
};

char *sum_strings(char *a,char *b) {
    int la=0;
    int lb=0;
    if (a) la=strlen(a);
    if (a) lb=strlen(b);
    char *temp=new char[la+lb+1];
    *temp=0;
    if (a) strcat(temp,a);
    if (b) strcat(temp,b);
    return temp;
};

char *sum_strings(char *a,char *b,char *c) {
    int la=0;
    int lb=0;
    int lc=0;
    if (a) la=strlen(a);
    if (b) lb=strlen(b);
    if (c) lc=strlen(c);
    char *temp=new char[la+lb+lc+1];
    *temp=0;
    if (a) strcat(temp,a);
    if (b) strcat(temp,b);
    if (c) strcat(temp,c);
    return temp;
};

int empty_string(char *a) {
    int len=strlen(a);
    for (int i=0;i<len;i++,a++) {
        if (*a!=' ' && *a!='\n' && *a!='\r')
            return 0;
    };
    return 1;
};

void convert_int_to_2(int what,char *where) {
    char tmp[MAX_LEN];
    *where=0;
    sprintf(tmp,"%i",what);
    if (what<10) strcat(where,"0");
    strcat(where,tmp);
};

void convert_time(int what,char *where) {
    int hours=what/int(3660);
    int mins=(what - hours*3660)/60;
    int secs= what-mins*60-hours*3660;
    char tmp[MAX_LEN];
    *where=0;
    if (hours>0) {
        convert_int_to_2(hours,tmp);
        strcat(where,tmp);
        strcat(where,":");
    };
	convert_int_to_2(mins,tmp);
	strcat(where,tmp);
   	if (!TIME_FORMAT){
		strcat(where,":");
    	convert_int_to_2(secs,tmp);
    	strcat(where,tmp);
    };
};

void string_to_low(char *what,char delim) {
    char *temp=index(what,delim);
    if (temp) {
        while (what!=temp) {
            if (*what>='A' && *what<='Z')
                *what+='a'-'A';
            what++;
        };
    };
};

int convert_from_hex(char what) {
    if (what>='0' && what<='9')
        return(what-'0');
    if (what>='a' && what<='f')
        return (10+what-'a');
    if (what>='A' && what<='F')
        return (10+what-'A');
    return 0;
};

char *parse_percents(char *what) {
    /* In the case if string not needed to correct
     */
    if (index(what,'%')==NULL) return NULL;
    /* Next string is too ugly because I use "new" in separate thread;
     */
    char *temp=new char[strlen(what)];
    char *percent,*where=temp,*old=what;
    while ((percent=index(old,'%'))) {
        strncpy(where,old,percent-old);
        where+=percent-old;
        old=percent+1;
        int num=0;
        if (*old) {
            num=convert_from_hex(*old);
            old++;
            if (*old) {
                num=num *16 + convert_from_hex(*old);
                old++;
            };
        };
        *where=char(num);
        where+=1;
    };
    strncpy(where,old,strlen(old));
    where[strlen(old)]=0;
    return temp;
};

void del_crlf(char *what) {
    if (!what) return;
    char *tmp;
    while((tmp=rindex(what,'\n')) || (tmp=rindex(what,'\r'))) {
        *tmp=0;
    };
};

void make_number_nice(char *where,int num) {
	switch (NICE_DEC_DIGITALS){
		case 1:{
    		sprintf(where,"%i",num);
    		int len=strlen(where);
    		if (len<4) return;
    		for (int i=len-3;i>0;i-=3,len++) {
        		for (int a=len-1;a>=i;a--)
            		where[a+1]=where[a];
        		where[i]=' ';
   		 	};
    		where[len]=0;
    		break;
    	};
    	case 2:{
    		int megs,kils;
    		kils=num/1024;
    		megs=kils/1024;
    		if (megs==0){
    			if (kils==0)
    				sprintf(where,"%i",num);
    			else
    				sprintf(where,"%iK",kils);
    		}else
    			sprintf(where,"%iM",megs);
    		break;
    	};
    	default:
    		sprintf(where,"%i",num);
   	};
};


