/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
#ifndef T_MAIN
#define T_MAIN
#include <pthread.h>
#include "download.h"
#include "liststr.h"
#include "dlist.h"
#include "mdlist.h"
#include "meter.h"
#include "mainlog.h"
#include <time.h>

struct tTwoStrings{
    char *one;
    char *two;
    tTwoStrings();
    void zero();
    ~tTwoStrings();
};

class tMain{
    time_t LastTime;
    tMLog *MainLog;
    int MsgQueue;
    int LastReadedBytes;
    void split_string(char *what,char *delim,tTwoStrings *out);
    void run_new_thread(tDownload *what);
    int complete();
    void add_dir(tStringList *dir,tDownload *parent);
    void make_file_visible(tDownload *what);
    void print_info(tDownload *what);
    void del_fataled();
    public:
    	void init();
    	void init_main_log();
    	void speed();
    	tAddr *analize(char *what);
        void main_circle();
        void del_completed();
        void del_all();
        void load_defaults();
        void redraw_logs();
        void stop_download(tDownload *what);
        void delete_download(tDownload *what);
        void continue_download(tDownload *what);
    	int add_downloading(char *adr,char *where);
    	void add_download_message(tDownload *what);
    	void run();
		void done();
};

void *download_last(void *);
int get_port_by_proto(char *proto);

extern tMeter *GlobalMeter;
extern tDList *RunList;
extern tDList *StopList;
extern tDList *CompleteList;
extern tDList *PausedList;
extern tDList *WaitList;
//************************************************/
#endif