/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
#include "mainlog.h"
#include "var.h"
#include "face/colors.h"
#include "face/list.h"
#include <stdio.h>

tMLog::tMLog() {
    start=time(NULL);
    list=NULL;
};

void tMLog::add_to_list(){
	tLogString *str=(tLogString *)Last;
    char a[MAX_LEN],useless[MAX_LEN],useful[MAX_LEN];
    sprintf(a,"%s ",ctime(&str->time));
    sscanf(a,"%s %s %s %s",useless,useless,useless,useful);
    char *data[]={useful,str->body};
    int row=gtk_clist_append(list,data);
    GdkColor color;
    switch (str->type) {
        case LOG_OK: {
                color=BLACK;
                break;
            };
        case LOG_SERVER: {
                color=BLUE;
                break;
            };
        case LOG_WARNING: {
                color=GREEN;
                break;
            };
        case LOG_ERROR: {
                color=RED;
                break;
            };
        default: color=BLACK;
    };
    GdkColormap *colormap = gtk_widget_get_colormap (MainWindow);
    gdk_color_alloc (colormap, &color);
    gtk_clist_set_foreground(list,row,&color);
};

void tMLog::print() {
    if (!list) return;
    tLogString *prom=(tLogString *)First;
    while (prom) {
        prom=(tLogString *)prom->prev;
    };
};


void tMLog::add(char *str,int len,int type) {
    tLogString *temp=new tLogString(str,len,type);
    temp->time=time(NULL);
    insert(temp);
   	add_to_list();
    Size+=len;
};

void tMLog::add(char *str,int type) {
    int len=strlen(str);
    tLogString *ins=new tLogString(str,len,type);
    insert(ins);
   	add_to_list();
    Size+=len;
};

void tMLog::init_list(GtkCList *clist){
	list=clist;
};

void tMLog::add(char *str) {
    int len=strlen(str);
    tLogString *ins=new tLogString(str,len,LOG_SERVER);
    insert(ins);
   	add_to_list();
	Size+=len;
};

void tMLog::dispose() {
    gtk_clist_remove(list,0);
    tStringList::dispose();
};

tLogString *tMLog::last() {
    return (tLogString *)tStringList::last();
};

tLogString *tMLog::next() {
    return (tLogString *)tStringList::next();
};

tLogString *tMLog::first() {
    return (tLogString *)tStringList::first();
};

tMLog::~tMLog() {
    done();
};