/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>

#include "dlist.h"
#include "config.h"
#include "liststr.h"
#include "var.h"
#include "locstr.h"

tDownload *get_download_from_clist(int row);

const char *LIST_FILE="list";

void write_one_node(int fd,tDownload *what) {
    tDownload *temp=what;
    write(fd,temp->info->protocol,strlen(temp->info->protocol));
    write(fd,"://",strlen("://"));
    if (temp->info->username && !equal(temp->info->username,"anonymous")) {
        write(fd,temp->info->username,strlen(temp->info->username));
        write(fd,":",strlen(":"));
        write(fd,temp->info->pass,strlen(temp->info->pass));
        write(fd,"@",strlen("@"));
    };
    write(fd,temp->info->host,strlen(temp->info->host));
    char data[MAX_LEN];
    sprintf(data,":%i",temp->info->port);
    write(fd,data,strlen(data));

    write(fd,temp->info->path,strlen(temp->info->path));
    if (temp->info->path[strlen(temp->info->path)-1]!='/')
        write(fd,"/",1);
    write(fd,temp->info->file,strlen(temp->info->file));
    write(fd,"\n",strlen("\n"));
    write(fd,temp->SavePath,strlen(temp->SavePath));
    write(fd,"\n",strlen("\n"));
};

void save_list() {
    char *homedir=getenv("HOME");
    char *path=new char[strlen(LIST_FILE)+strlen(homedir)+strlen(CFG_DIR)+3];
    *path=0;
    strcat(path,homedir);
    strcat(path,"/");
    strcat(path,CFG_DIR);
    strcat(path,"/");
    strcat(path,LIST_FILE);
    remove(path);
    int fd=open(path,O_TRUNC | O_CREAT |O_RDWR,S_IRUSR | S_IWUSR);
    delete(path);
    if (fd<0) {
        printf("Can't create file: %s",path);
        return;
    };
    int i=0;
    tDownload *temp=get_download_from_clist(i);
    // *** Calculate amount of elements ***
    while (temp) {
        i++;
        temp=get_download_from_clist(i);
    };
    // *** Saving them in reverse order  ***
    for (int a=i-1;a>=0;a--) {
        temp=get_download_from_clist(a);
        write_one_node(fd,temp);
    };
    close(fd);
};

void read_list(tStringList *where) {
    char *homedir=getenv("HOME");
    char *path=new char[strlen(LIST_FILE)+strlen(homedir)+strlen(CFG_DIR)+3];
    *path=0;
    strcat(path,homedir);
    strcat(path,"/");
    strcat(path,CFG_DIR);
    strcat(path,"/");
    strcat(path,LIST_FILE);
    int fd=open(path,O_RDONLY,S_IRUSR | S_IWUSR);
    delete(path);
    if (fd>0) {
        char temp[MAX_LEN];
        char *cur=temp;
        while(read(fd,cur,1)>0) {
            while(*cur!='\n') {
                cur++;
                if (read(fd,cur,1)==0) break;
            };
            *cur=0;
            where->add(temp);
            cur=temp;
        };
        close(fd);
    };
};
