/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
#ifndef T_VARIABLE
#define T_VARIABLE

#define STATUS_TRIVIAL -1
#define STATUS_FATAL -3
#define STATUS_TIMEOUT -2
#define STATUS_CMD_ERR -4
#define STATUS_BAD_ANSWER -5
#define MAX_LEN 4048
#include <pthread.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/types.h>
#include "history.h"

extern tHistory *UrlHistory;
extern tHistory *PathHistory;

extern key_t LogsMsgQueue;

extern pthread_mutex_t READED_BYTES_MUTEX;
extern int READED_BYTES;

extern char *FTP_SERVER_OK;
extern char *FTP_USER_OK;
extern char *FTP_PASS_OK;
extern char *FTP_PORT_OK;
extern char *FTP_CWD_OK;
extern char *FTP_RETR_OK;
extern char *FTP_QUIT_OK;
extern char *FTP_READ_OK;
extern char *FTP_ABOR_OK;
extern char *FTP_REST_OK;

extern char *DEFAULT_PASS;
extern char *DEFAULT_USER;


extern int RETRY_TIME_OUT;
extern int MAX_RETRIES;
extern int MAX_LOG_LENGTH;
extern int MAX_THREADS;
extern int METER_LENGTH;
extern int TIME_OUT;

/* Flags
 */
extern int RETRY_IF_NOREGET;
extern int RECURSIVE_OPTIMIZE;
extern int NICE_DEC_DIGITALS;
extern int TIME_FORMAT;
extern int DELETE_FATAL;
extern int DELETE_COMPLETED;
extern char *GLOBAL_SAVE_PATH;
extern char *VERSION_NAME;
extern int WINDOW_X_POSITION;
extern int WINDOW_Y_POSITION;
extern int WINDOW_WIDTH;
extern int WINDOW_HEIGHT;
extern int WINDOW_CLIST_HEIGHT;

extern char *DEFAULT_PROTO;
extern int BLOCK_READ;
extern int  DEL_COMPLETED;
extern int  DEL_FATALED;

extern int SPEED_LIMIT;
extern int SPEED_LIMIT_1;
extern int SPEED_LIMIT_2;
extern int SPEED_LIMIT_3;
extern pthread_mutex_t SPEED_LIMIT_MUTEX;
#endif